#include "pfield.h"
#include "game.h"


#ifndef BEAST_H
#define BEAST_H

class beast : public game
    {
    public:
    const int MX=40;
    const int MY=23;
    int cur_level;

    pfield *playfield;


    static const int BKGR=0;
    static const int WALL=1;
    static const int BEAST=2;
    static const int BLOCK=3;
    static const int SUPER_BEAST=4;
    static const int CRAZY_BEAST=5;
    static const int PEGGS=6;
    static const int REGGS=7;
    static const int MAX_THINGS=8;

    int PX;
    int PY;

    mvid *pictures[MAX_THINGS];
    mvid *player_pictures[max_players];

    int count;

    void next_turn();
    int cur_beast;
           
    void move_beast(int x, int y);
    void kill_player(int j);


    int surrounded(int x, int y);

    int really_push_blocks(int x, int y, int mx, int my);


    void move_player(int p);


    int game_resize_pictures();


    audioclip smoosh,death,hatch,explode;

    beast(rustic *r);

    ~beast();

    void newgame(int level);
    int game_update(vid *onto);

    int push_blocks(int p,int x, int y, int mx, int my);
    };



#endif
