#include "digger.h"


void digger::next_turn()
    {
    int x,y,i,j;

    if (special==1)
        {
        special=0;
        newgame(cur_level+1);
        }

    i=0;

    int q;

    move_hobbins();

    for (j=0; j<top_rustic->total_players; j++)
        {
        if (top_rustic->players[j]->alive==1)
            {
            i++;
            move_player(j);
            }
        }

    move_goldbags();



    int adlev=0;
    j=0;
    for (x=0; x<MX; x++)
        for (y=0; y<MY; y++)
            if (playfield->get(x,y)==GEM) j++;
    if (j==0) {adlev=1;i=0;}

    if (i==0)
        {
        x=0;
        for (j=0; j<top_rustic->total_players; j++)
            if (top_rustic->players[j]->lives>0)
                x+=top_rustic->players[j]->lives;
      //  if (adlev!=0)
      //      winlevel.play();
        if (x==0)
            alive=0;
            else
            newgame(cur_level+adlev);
        }
    }




int digger::game_resize_pictures()
    {
    int x,y;

    int i;

    PX=game_x/MX;
    PY=game_y/MY;
    if (PX<1 | PY<1) return(-1);

    int mx,my; int j,k;
    mx=pictures->myimages[0]->data[0];
    my=pictures->myimages[0]->data[1];


    j=GEM;
        for (k=2; k<(mx*my*4+2); k++)
            if (pictures->myimages[j]->data[k]==CLEAR_COLOR)
                pictures->myimages[j]->data[k]=
                pictures->myimages[DIRT]->data[k];

    unsigned char *img = new unsigned char[PX*PY];

    if (ginit==1)
        {
        for (i=0; i<max_players; i++)
        for (j=0; j<4; j++)
        for (k=0; k<3; k++)
            delete player_pictures[i][j][k];
        }

    int irotmatx[4][6] = {
        0,-1,PY-1, 1,0,0,
        0,1,0, 1,0, 0,

        -1,0,PX-1,0,1,0,
        1,0,0,0,1,0,
        };

    for (i=0; i<max_players; i++)
        for (j=0; j<4; j++)
        for (k=0; k<3; k++)
        {
        if (j<2) pictures->resize(PY,PX); else
                 pictures->resize(PX,PY);

        mvid *m=pictures->imageint(DIGGER+k);
        int clr;
        int nx,ny;
        for (y=0; y<PY; y++)
            for (x=0; x<PX; x++)
                {
                nx=x*irotmatx[j][0]+y*irotmatx[j][1]+irotmatx[j][2];
                ny=x*irotmatx[j][3]+y*irotmatx[j][4]+irotmatx[j][5];
                clr=m->getpixel(nx,ny);
                if (clr==0) clr=CLEAR_COLOR;
                if (clr!=CLEAR_COLOR)
                    clr=top_rustic->players[i]->color;
                img[y*PX+x]=clr;
                }
        player_pictures[i][j][k]=makeimage(img,PX,PY);
        }

    pictures->resize(PX,PY);


   /* for (i=0; i<MX*MY; i++)
        a_play_field[i]=1;
    */
    playfield->all_on();
    delete [] img;
    ginit=1;
    return(1);
    }


digger::digger(rustic *r)
    : game(r)
    {
    gamename="Digger";
    playfield = new pfield(MX,MY);
    playfield->defret=WALL;

    PX=8;
    PY=8;

    pictures = new graflib("digger.grf");
    refresh_rate=.3f/(float)div_thing;

    top_rustic->key_form=top_rustic->LET_GO;

    level_data = new levellib("digger.lvl");
    cur_level=-1;

    death.load("scream.wav");
    bonus.load("doodle.wav");
    goldbonus.load("trumpet.wav");
    bagcrash.load("bang.wav");
    hobbinsmear.load("smush.wav");
//    winlevel.load("digwin.wav");
    newgame(0);
    }

digger::~digger()
    {
    delete playfield;
    delete level_data;
    delete pictures;
    int i,j,k;
    for (i=0; i<max_players; i++)
        for (j=0; j<4; j++)
        for (k=0; k<3; k++)
        delete player_pictures[i][j][k];
    }

int digger::pplayfield_get(int p, int x,int y)
    {
    int px,py;
    int pxd,pyd;
    px=top_rustic->players[p]->x;
    py=top_rustic->players[p]->y;
    pxd=px/div_thing;
    pyd=py/div_thing;

    int dx,dy;
    dx=x-pxd;
    dy=y-pyd;

    int tdx=0,tdy=0;
    if (dx<0) {tdx=-div_thing/2-1;dx++;}
    if (dy<0) {tdy=-div_thing/2-1;dy++;}
    if (dx>0) {tdx=div_thing/2;dx--;}
    if (dy>0) {tdy=div_thing/2;dy--;}
    tdx+=dx*div_thing;
    tdy+=dy*div_thing;

    x=px+tdx+div_thing/2;
    y=py+tdy+div_thing/2;
    x/=div_thing;
    y/=div_thing;
    
    return(playfield->get(x,y));
    }

void digger::pplayfield_set(int p, int x, int y, int c)
    {
    int px,py;
    int pxd,pyd;
    px=top_rustic->players[p]->x;
    py=top_rustic->players[p]->y;
    pxd=px/div_thing;
    pyd=py/div_thing;

    int dx,dy;
    dx=x-pxd;
    dy=y-pyd;

    int tdx=0,tdy=0;
    if (dx<0) {tdx=-div_thing/2-1;dx++;}
    if (dy<0) {tdy=-div_thing/2-1;dy++;}
    if (dx>0) {tdx=div_thing/2;dx--;}
    if (dy>0) {tdy=div_thing/2;dy--;}
    tdx+=dx*div_thing;
    tdy+=dy*div_thing;

    x=px+tdx+div_thing/2;
    y=py+tdy+div_thing/2;
    x/=div_thing;
    y/=div_thing;
    
    playfield->set(x,y,c);
    }


void digger::newgame(int level)
    {
    int i,x,y;

    int newlev=0;
    if (cur_level!=level) newlev=1;
    cur_level=level;

    int sx,sy;
    sx=1;
    sy=2;
    int c;
    i=0;
    int j;

    x=MX/2;
    y=MY-1;
    for (j=0; j<top_rustic->total_players; j++)
        {
        top_rustic->players[j]->x=x*div_thing;
        top_rustic->players[j]->y=y*div_thing;
        }

    max_total_hobbins=(cur_level/8)*2+6;
    total_hobbins=0;
    hobbin_wait=75-((cur_level/8)*25);
    if (hobbin_wait<50) hobbin_wait=50;

    for (j=0; j<max_hobbins; j++)
        {
        hobbins[j].x=(j%2)*(MX-1)*div_thing;
        hobbins[j].y=0;
        hobbins[j].tm=hobbin_wait*j;
        hobbins[j].alive=0;
        }

    if (newlev==1)
    for (j=0; j<max_goldbags; j++)
        {
        goldbags[j].state=-1;
        }


    j=0;

    int cur_screen;
    if (cur_level<=7)
        cur_screen=cur_level;
        else
        cur_screen=(cur_level%4)+4;

    int gl=0;
    if (newlev==1)
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            {
            c=level_data->mylevels[cur_screen]->get(x,y);
            switch(c)
                {
                case BAG:
                    if (gl<max_goldbags)
                        {
                        goldbags[gl].x=x*div_thing;
                        goldbags[gl].y=y*div_thing;
                        goldbags[gl].t=0;
                        goldbags[gl].state=0;
                        goldbags[gl].mx=0;
                        goldbags[gl].my=0;
                        goldbags[gl].j=0;
                        }
                    gl++;
                    c=DIRT;
                    break;
                case BKGR:
                case DIRT:
                case GEM:
                    break;
                default:
                    c=BKGR;  // some of the levels are "corrupt"
                    break;   // with invalid junk that skrews stuff up
                }
            playfield->set(x,y,c);
            }



    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {
 //       top_rustic->players[i]->x=MX/4+(MX/2)*(i%2);
 //       top_rustic->players[i]->y=MY/4+(MY/2)*(i/2);

        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->j=0;
        top_rustic->players[i]->jl=0;
        top_rustic->players[i]->len=0;
        top_rustic->players[i]->p=PLAYER_RIGHT;
 //       playfield->set(top_rustic->players[i]->x,top_rustic->players[i]->y,BKGR);
        }

    alive=1;
    char s[80];
    sprintf(s,"Level %d",cur_level+1);
    pause(s);
    }



int digger::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;
    cur_dig_frame++;

    int thisframe=cur_dig_frame;

    int hrot[4] = {1,0,2,0};
    int drot[4] = {1,2,1,0};

    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {
            g->domvid(
                pictures->imageint(playfield->get(x,y)),
                x*PX,y*PY);
            playfield->a_set(x,y,0);
            c++;

            for (i=0; i<max_goldbags; i++)
                if ((goldbags[i].x/div_thing)==x &
                    (goldbags[i].y/div_thing)==y &
                     goldbags[i].state!=-1 &
                     goldbags[i].moved==0)
                        {
                        g->idomvid(pictures->imageint(BAG),
                            goldbags[i].x*PX/div_thing,
                            goldbags[i].y*PY/div_thing);
                        }

            }

    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->alive==1)
                {
                top_rustic->players[i]->moved=0;

             //   if (top_rustic->players[i]->j==0)
                g->domvid(
                    player_pictures[i]
                        [top_rustic->players[i]->p]
                        [drot[thisframe%4]],
                    top_rustic->players[i]->x*PX/div_thing,
                top_rustic->players[i]->y*PY/div_thing);

                /*
                else
                g->domvid(
                 player_pictures[rand()%max_players][thisframe%2],top_rustic->players[i]->x*PX/div_thing,
                top_rustic->players[i]->y*PY/div_thing);
                */
                c++;
                }

    for (i=0; i<max_hobbins; i++)
        if (hobbins[i].alive==1)
                {
                hobbins[i].moved=0;
                g->domvid(
                    pictures->imageint(NOBBIN+hrot[thisframe%4]),hobbins[i].x*PX/div_thing,
                    hobbins[i].y*PY/div_thing);
                c++;
                }

    for (i=0; i<max_goldbags; i++)
        if (goldbags[i].moved!=0 &
            goldbags[i].state!=-1)
            {
            goldbags[i].moved=0;
            g->idomvid(pictures->imageint(BAG),
                goldbags[i].x*PX/div_thing,
                goldbags[i].y*PY/div_thing);
            }
    }



    if (c!=0)
        return(1);

    return(0);
    }


void digger::move_player(int p)
    {
    int j;
    int x=top_rustic->players[p]->x;
    int y=top_rustic->players[p]->y;
    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;

    top_rustic->players[p]->jl++;

    if (top_rustic->players[p]->j>0) top_rustic->players[p]->j--;
    key_check(p);
    check(p);

    if (top_rustic->players[p]->j!=0) top_rustic->players[p]->moved=1;


    if (x!=top_rustic->players[p]->x | y!=top_rustic->players[p]->y)
        {

        for (j=0; j<top_rustic->total_players; j++)
            top_rustic->players[j]->moved=1;

        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));

        x-=div_thing-1;
        y+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        }


     x=top_rustic->players[p]->x+(div_thing/2);
     y=top_rustic->players[p]->y+(div_thing/2);

    check(p);
    if (playfield->get(x/div_thing,y/div_thing) != WALL)
        playfield->set(x/div_thing,y/div_thing,BKGR);
}


void digger::key_check(int p)
  {
  int fx=top_rustic->players[p]->x;//div_thing;
  int fy=top_rustic->players[p]->y;//div_thing;
  int x=fx/div_thing;
  int y=fy/div_thing;


  int i;

  int k;

    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;




//        if (pplayfield_get(p,x,y+my) != DIRT)

int omy=my;
int omx=mx;

int hdt=div_thing/2;

if ((fx%div_thing)!=0) my=0;
if ((fy%div_thing)!=0) mx=0;

if (mx!=0 & my!=0) {omy=0;my=0;}

if (omx==0 & mx==0 & omy!=my)
    if (fx%div_thing<hdt)
        mx=-1;  else  mx=1;

if (omy==0 & my==0 & omx!=mx)
    if (fy%div_thing<hdt)
        my=-1;  else  my=1;

int rp=top_rustic->players[p]->p;

for (i=0; i<max_goldbags; i++)
    {
    if (goldbags[i].state!=-1 & 
        top_rustic->players[p]->x ==
        goldbags[i].x &
        (top_rustic->players[p]->y+(my*div_thing)) ==
        goldbags[i].y)
            my=0;
    }
    

if (mx!=0 | my!=0)
    {
    if (mx!=0)
        {
        if (mx<0) rp=PLAYER_LEFT;
            else
            rp=PLAYER_RIGHT;
        }
        else
        {
        if (my<0)
            rp=PLAYER_UP;
            else
            rp=PLAYER_DOWN;
        }
    }
top_rustic->players[p]->p=rp;
            

        
push_gold(p,mx,fx,fy);

if (pplayfield_get(p,x+mx,y+my) != WALL)
    {
    x+=mx; y+=my;
    }
    else
    if (pplayfield_get(p,x+mx,y) != WALL)
        x+=mx;
        else
        if (pplayfield_get(p,x,y+my) != WALL)
            y+=my;



  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);

  if (top_rustic->players[p]->x<0) top_rustic->players[p]->x=0;
  if (top_rustic->players[p]->y<0) top_rustic->players[p]->y=0;

  //return (0);
  }


int digger::nplayfield_get(int p, int x,int y)
    {
    int px,py;
    int pxd,pyd;
    px=hobbins[p].x;
    py=hobbins[p].y;
    pxd=px/div_thing;
    pyd=py/div_thing;

    int dx,dy;
    dx=x-pxd;
    dy=y-pyd;

    int tdx=0,tdy=0;
    if (dx<0) {tdx=-div_thing/2-1;dx++;}
    if (dy<0) {tdy=-div_thing/2-1;dy++;}
    if (dx>0) {tdx=div_thing/2;dx--;}
    if (dy>0) {tdy=div_thing/2;dy--;}
    tdx+=dx*div_thing;
    tdy+=dy*div_thing;

    x=px+tdx+div_thing/2;
    y=py+tdy+div_thing/2;
    x/=div_thing;
    y/=div_thing;
    
    return(playfield->get(x,y));
    }


void digger::move_hobbins()
{
int x,y,i,j;
for (i=0; i<max_hobbins; i++)
    if (hobbins[i].alive==1)
    {

    x=hobbins[i].x;
    y=hobbins[i].y;


  for (j=0; j<max_goldbags; j++)
    if (goldbags[j].my!=0)
    if (abs(goldbags[j].x-x) < div_thing &
        abs(goldbags[j].y-y) < div_thing)
        {
        if (goldbags[j].p_pushed!=-1)
            top_rustic->players[goldbags[j].p_pushed]->score+=250;
        hobbins[i].x=(i%2)*(MX-1)*div_thing;
        hobbins[i].y=0;
        hobbins[i].tm=hobbin_wait;
        hobbins[i].alive=0;
        hobbinsmear.play();
        }


        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));

        x-=div_thing-1;
        y+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));


    hobbins[i].moved=1;

    x=hobbins[i].x;
    y=hobbins[i].y;

    int mx,my;

    mx=hobbins[i].mx;
    my=hobbins[i].my;
    int xd,yd;
    xd=x/div_thing;
    yd=y/div_thing;

if (
    nplayfield_get(i,xd+mx,yd+my) == BKGR |
    nplayfield_get(i,xd+mx,yd+my) == GOLD)
    {
    x+=mx; y+=my;
    }
    else
    if (
        nplayfield_get(i,xd+mx,yd) == BKGR |
        nplayfield_get(i,xd+mx,yd) == GOLD)
        x+=mx;
        else
        if (nplayfield_get(i,xd,yd+my) == BKGR|
            nplayfield_get(i,xd,yd+my) == GOLD)
            y+=my;


    if (x<0) x=0;
    if (y<0) y=0;

    if (x!=hobbins[i].x | y!=hobbins[i].y)
        {
        hobbins[i].t--;
   //         hobbins[i].x+=hobbins[i].mx;
//        hobbins[i].y+=hobbins[i].my;
        hobbins[i].y=y;
        hobbins[i].x=x;
        }
        else
        hobbins[i].t=0;

    if (hobbins[i].t<=0)
        {
        int omx,omy;
        omx=hobbins[i].mx;
        omy=hobbins[i].my;

        int cnt=0;

        while (cnt < 10 &
            ((hobbins[i].mx==omx & hobbins[i].my==omy) |
            (hobbins[i].mx==(-omx) & hobbins[i].my==(-omy)))
            )
            {
            cnt++;
            hobbins[i].t=(1+rand()%(50/div_thing))*div_thing;
            hobbins[i].mx=1-(2*(rand()%2));
            hobbins[i].my=1-(2*(rand()%2));

            if (hobbins[i].mx !=0 & hobbins[i].my!=0)
                if ((rand()%2)==0)
                    hobbins[i].mx=0;
                    else
                    hobbins[i].my=0;

            if (
                playfield->get(
                (hobbins[i].x/div_thing)+hobbins[i].mx,
                (hobbins[i].y/div_thing)+hobbins[i].my
                )!=BKGR
                &
                playfield->get(
                (hobbins[i].x/div_thing)+hobbins[i].mx,
                (hobbins[i].y/div_thing)+hobbins[i].my
                )!=GOLD
                 )
                {
                hobbins[i].mx=omx;
                hobbins[i].my=omy;
                }
            }
        }
    }
    else
    {
    hobbins[i].tm--;
    if (hobbins[i].tm<=0 & total_hobbins < max_total_hobbins)
        {
        hobbins[i].alive=1;
        total_hobbins++;
        }
    }
}

void digger::kill_player(int p)
{
if (top_rustic->players[p]->alive!=0)
{
top_rustic->players[p]->lives--;
top_rustic->players[p]->alive=0;
death.play();
}
}

void digger::check(int p)
  {
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;
  int j=top_rustic->players[p]->j;
  int score=top_rustic->players[p]->score;


  if (pplayfield_get(p,x,y) ==  GEM)
    {
    if (top_rustic->players[p]->jl<(div_thing*2))
        top_rustic->players[p]->len++;
        else
        top_rustic->players[p]->len=1;

    top_rustic->players[p]->jl=0;


    score=score+25;
    pplayfield_set(p,x,y,0);
    bonus.playfreq(1000+(1000*top_rustic->players[p]->len/8));

    if (top_rustic->players[p]->len==8)
        {
        score=score+250;
        top_rustic->players[p]->len=0;
        }
    }
  if (pplayfield_get(p,x,y) ==  GOLD) {goldbonus.play(); score=score+500;pplayfield_set(p,x,y,0);
    }

  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->score=score;

  int i;
  if (top_rustic->players[p]->j==0)
  for (i=0; i<max_hobbins; i++)
  if (hobbins[i].alive==1)
    {
    if (abs(hobbins[i].x-top_rustic->players[p]->x) < div_thing &
        abs(hobbins[i].y-top_rustic->players[p]->y) < div_thing)
        {
        kill_player(p);
        }
    }

  for (i=0; i<max_goldbags; i++)
    if (goldbags[i].my!=0 & goldbags[i].p_pushed!=p)
    if (abs(goldbags[i].x-top_rustic->players[p]->x) < div_thing &
        abs(goldbags[i].y-top_rustic->players[p]->y) < div_thing)
        {
        kill_player(p);
        if (goldbags[i].p_pushed!=-1)
            top_rustic->players[goldbags[i].p_pushed]->score+=500;
        }
  }

void digger::move_goldbags()
    {
    int i;
    int x,y;
    for (i=0; i<max_goldbags; i++)
        if (goldbags[i].state!=-1)
            {
            if (goldbags[i].my!=0 | goldbags[i].mx!=0)
                {
                x=goldbags[i].x;
                y=goldbags[i].y;
                int x1=goldbags[i].x+(div_thing-1);
                int y1=goldbags[i].y+(div_thing-1);
                x/=div_thing;
                y/=div_thing;
                x1/=div_thing;
                y1/=div_thing;
                playfield->a_set(x,y,1);
                playfield->a_set(x,y1,1);
                playfield->a_set(x1,y,1);
                playfield->a_set(x1,y1,1);

                goldbags[i].y+=goldbags[i].my;
                goldbags[i].x+=goldbags[i].mx;

                goldbags[i].j+=goldbags[i].my;

                goldbags[i].moved=1;
                }

            x=goldbags[i].x/div_thing;
            y=goldbags[i].y/div_thing;


            if ((goldbags[i].x%div_thing) == 0 &
                (
                playfield->get(x,y+1) == BKGR |
                playfield->get(x,y+1) == GOLD))
                {
                goldbags[i].t++;

                if (goldbags[i].t==26)
                    {
                    goldbags[i].p_pushed=-1;
                    goldbags[i].my=2;
                    }

                if (goldbags[i].mx != 0)
                    {
                    goldbags[i].my=2;
                    goldbags[i].t=27;
                    }

                if (goldbags[i].j>div_thing)
                    goldbags[i].state=2;
                }
                else
                {
                goldbags[i].t=0;
                goldbags[i].j=0;

                goldbags[i].my=0;
                if (goldbags[i].state==2)
                    {
                    goldbags[i].state=-1;
                    playfield->set(x,y,GOLD);
                    bagcrash.play();
                    }
                    else
                    {
                    goldbags[i].state=0;
                    goldbags[i].j=0;
                    }
                }

            if ((goldbags[i].x%div_thing) == 0)
                goldbags[i].mx=0;

            if (goldbags[i].my!=0)
                goldbags[i].mx=0;
            }
    }

void digger::push_gold(int p, int mx, int x, int y)
    {
    int i;
    if (mx==0) return;
    x+=mx*(div_thing/2);

    x+=div_thing/2;
    x/=div_thing;
    y/=div_thing;
     
    for (i=0; i<max_goldbags; i++)
      if (goldbags[i].state==0 &
            goldbags[i].my==0)
        {
        int gx,gy;
        gx=(goldbags[i].x+div_thing/2)/div_thing;
        gy=goldbags[i].y/div_thing;
        if (x==gx & y==gy)
            {
            goldbags[i].p_pushed=p;
            goldbags[i].mx=mx;
            }
        }
    }
                 
                
            

