#ifndef GRAFLIB_H
#define GRAFLIB_H

#define BYTES_PER_BLOCK 4

#include "../vid/mvid.h"

class grafimage
    {
    public:
    mvid *rendered;
    int MX, MY;
    unsigned char *data;
    grafimage(unsigned char *d);
    void resize(int mx, int my);
    ~grafimage();
    };


#define GRAF_LIBSIZE 71

class graflib
    {
    public:
    grafimage *myimages[GRAF_LIBSIZE];
    int lookup[256];
    int dMX,dMY;

    void load(char *fname);
    void save(char *fname);

    void make_lookup();
    graflib(int mx, int my);
    graflib(char *fname);

    void resize(int mx, int my);
    void imageresize(int mx, int my);
    mvid *image(unsigned char c);
    mvid *imageint(int c);

    ~graflib();
    };


#endif
