#include "classes.h"

//MENU_ITEM----------------------------------------------------
menu_item::menu_item(sfont *f, action_listener *p, menuitem *m)
    : text_box(f,m->field)
    { omb=0; parent=p; mi=m;}

void menu_item::mouse(mouseevent *e)
    {
    if (omb!=e->b & e->b==0)
        parent->action(mi->value);
    omb=e->b;
    }

menu_item::~menu_item() {}

//VERT_MENU----------------------------------------------------
int vert_menu::update(vid *onto)
    {
    onto->fillrect(fnt->bg,0,0,MX,MY);
    return(popfocus_panel::update(onto));
    }

vert_menu::vert_menu(sfont *f,action_listener *p, menuitem *m, int msl, int hms)
    : popfocus_panel((msl+2)*f->MX,hms*f->MY)
    {
    parent=p;
    fnt=f;
    mi=m;
    total_hms=hms;
    int i;
    for (i=0; i<total_hms; i++)
        {
       // printf ("-->%s\n",mi[i].field);
        hm[i]=new menu_item(fnt,p,&mi[i]);
        add(hm[i],fnt->MX,i*fnt->MY);
        }
    }

vert_menu::~vert_menu()
    {
    int i;
    for (i=0; i<total_hms; i++)
        delete hm[i];
    }

//PULLDOWN_MENU----------------------------------------------------
int pulldown_menu::update(vid *onto)
        {
        onto->fillrect(fnt->bg,0,0,MX,MY);
        return(panel::update(onto));
        }

pulldown_menu::pulldown_menu(sfont *f, panel *p, menuitem *m, action_listener *a)
    : panel(PANEL_ENTIRE,f->MY)
    {
    fnt=f; panl=p; al=a; mi=m;
    total_ms=0;

    int cur=0;
    int tx=f->MX;
    while (mi[cur].field[0]!='^')
        {
        mi[cur].value=total_ms;
        hm[total_ms]=new menu_item(fnt,this,&mi[cur]);
        add(hm[total_ms],tx,0);
        tx+=f->width(mi[cur].field)+2*f->MX;

       //  printf ("top:%s\n",mi[cur].field);
        cur++;
        int count=0;
        int mls=0;
        while (mi[cur+count].field[0]!='^')
            {
       //     printf (":%s\n",mi[cur+count].field);
            if (strlen(mi[cur+count].field)>mls)
                mls=strlen(mi[cur+count].field);
            count++;
            }
        vm[total_ms]=new vert_menu(fnt,al,&mi[cur],mls,count);
        total_ms++;
        cur+=count;
        cur++;
        }
    }

void pulldown_menu::action(int a)
    {
    panl->add(vm[a],hm[a]->PX-fnt->MX,fnt->MY);
    }

pulldown_menu::~pulldown_menu()
    {
    int i;
    for (i=0; i<total_ms; i++)
        {
        delete vm[i];
        delete hm[i];
        }
    }
