#include <string.h>
//#include <conio.h>
#include <stdlib.h>
#include <stdio.h>

#include "classes.h"

edit_textbox::edit_textbox(sfont *f, char *s,int l)
    : dbuff_component(l*f->MX,f->MY)
    {
    str=s;
    fnt=f;
    len=l;
    changes=1;
    ohf=FOCUS_HAVE;
    cur=strlen(str);
    }

int edit_textbox::update()
    {
    if (ohf!=have_focus) changes=1;
    if (changes==1)
        {
        myvid->fillrect(fnt->bg,0,0,MX,MY);
        fnt->print_text(myvid,str,0,0);
        if (have_focus==FOCUS_HAVE)
            myvid->line(fnt->fg,cur*fnt->MX,fnt->MY-2,
                            (cur+1)*fnt->MX,fnt->MY-2);
        ohf=have_focus;
        }
    int ch=changes;
    changes=0;
    return(ch);
    }

void edit_textbox::resize()
    {
    if (MX != (len*fnt->MX) |
        MY != fnt->MY)
        dbuff_component::resize(len*fnt->MX,fnt->MY);
    }
    


void edit_textbox::key(keyevent *e)
    {
    changes=1;
    switch(e->ch)
        {
        case '\r':
        case '\n':
        case '\t':
            require_focus=FOCUS_REJECTED;
            break;
        case '\b':
            if (cur>0)
                {
                cur--;
                str[cur]=0;
                }
            break;
        default:
            if (cur<len)
                {
                str[cur]=e->ch;
                str[cur+1]=0;
                cur++;
                }
            break;
        }
    }

edit_textbox::~edit_textbox() {}

edit_numberbox::edit_numberbox(sfont *f, int *n, int l)
    : edit_textbox(f,new char[l+1],l)
    {
    num=n;
    int i;
    for (i=0; i<len; i++)
        str[i]=0;
    //itoa((*num),str,10);
    sprintf(str,"%d",*num);
    cur=strlen(str);
    }

void edit_numberbox::key(keyevent *e)
    {
    edit_textbox::key(e);
    (*num)=atoi(str);
    }

edit_numberbox::~edit_numberbox()
    {
    delete [] str;
    }
