#include "allegro.h"
#include "player.h"

#include "../gui/classes.h"
#include "rustic.h"
#include "menu.h"

#define TOTALKEYS  128
unsigned char allkeys[TOTALKEYS];
void getallkeys()
    {
    int i;
    for (i=0; i<TOTALKEYS; i++)
        allkeys[i]|=key[i];
    }
    
//=key;



    void rustic::key(keyevent *e)
        {
        int k=e->k;
        cur_key=e->k;
        switch (k)
            {
            }
        allkeys[e->k]|=1;

        panel::key(e);
        }


    void rustic::dokeys()
        {
        int i,j,n,x;

        if (key_form!=HIT_ON)
            getallkeys();

        if (key_form==LET_GO | key_form==HIT_ON)
            {
            for (i=0; i<total_players; i++)
                {
                for (j=0; j<4; j++)
                    if (allkeys[players[i]->keys[j]]==0)
                        players[i]->direction[j]=0;
                players[i]->calc_mxmy();
                }
            }
    
        for (i=0; i<total_players; i++)
            {
            for (j=0; j<4; j++)
                if (allkeys[players[i]->keys[j]]!=0)
                    {
                    n=1;
                    if (key_form==HOLD_ON)
                        if ((players[i]->cur_direction&2)==(j&2))
                            n=0;
                            else
                            for (x=0; x<4; x++)
                                players[i]->direction[x]=0;
                    if (n==1)
                        players[i]->direction[j]=1;
                    }
            players[i]->calc_mxmy();
            players[i]->dmx=players[i]->mx;
            players[i]->dmy=players[i]->my;
            if (i==0)
                {
		/*
                int dmx,dmy;
                get_mouse_mickeys(&dmx,&dmy);
            //    players[i]->dmx+=((double)dmx*20.0)/(double)SCREEN_W;
            //    players[i]->dmy+=((double)dmy*13.0)/(double)SCREEN_H;
                players[i]->dmx+=((double)dmx*20.0)/(double)100.0;
                players[i]->dmy+=((double)dmy*20.0)/(double)100.0;
               // players[i]->dmx+=((double)dmx*20.0)/(double)360.0;
               // players[i]->dmy+=((double)dmy*20.0)/(double)360.0;
               */ 
	       }
            }
        for (i=0; i<TOTALKEYS; i++)
            allkeys[i]=0;
        }


    rustic::rustic(long x, long y)
        : panel(x,y)
        {
        cur_game=0;
        players[0] = new player("Phil",9,this);
        players[1] = new player("Nan",12,this);
        players[2] = new player("Boss",10,this);
        players[3] = new player("Doug",14,this);
        total_players=1;
        key_form=LET_GO;
        }

    rustic::~rustic()
        {
        int i;
        for (i=0; i<4; i++)
            delete players[i];
        }

int rustic::update(vid *onto)
   {
   dokeys();
   panel::update(onto);
   }

void rustic::change_screen(component *c)
    {
    component *f=focus;
    remove(focus);
    delete f;
    add(c,0,0);
    }


int main(int argc, char *argv[])
    {
    printf ("Welcome to the Rustic Classics by Philip Hassey!\n");
    printf ("play the java version at www.imitationpickles.org\n\n");
    topwindow *mywin;
    if (argc!=3)
	    mywin=new topwindow(TOPWINDOW_NO_DBUFF|TOPWINDOW_MOUSE);
        else
    	    mywin=new topwindow(TOPWINDOW_NO_DBUFF|TOPWINDOW_MOUSE,atoi(argv[1]),atoi(argv[2]));

    rustic *myrustic=new rustic(PANEL_ENTIRE,PANEL_ENTIRE);

    mywin->add(myrustic,0,0);
    mywin->focus=myrustic;

   // install_mouse();
    
    set_window_title("The Rustic Classics");
    
    rusticmenu *mymenu=new rusticmenu(myrustic);
    myrustic->add(mymenu,0,0);
    mywin->run();

    delete myrustic;

    delete mywin;
    return(0);
    }

END_OF_MAIN();
