#include "game.h"
#include "player.h"
#include "rustic.h"
#include "../vid/svid.h"
#include "high.h"
                                          
//#include <conio.h>
#include <stdlib.h>
#include <time.h>

#include "allegro.h"

#define UNKNOWN_GAME_NAME "unknown"



//the folowing is due to the "i_love_bill" problem..
#define GAME_MTPS 200

volatile long game_counter;
void game_time_handler()
    {
    game_counter++;
    }
END_OF_FUNCTION(game_time_handler);

    game::game(rustic *r)
        : component(PANEL_ENTIRE,PANEL_ENTIRE)
        {
        int i,j;
        gamename=UNKNOWN_GAME_NAME;
        savescores=1;
        first_frame=1;
        top_rustic=r;
        ginit=0;
        alive=0;
        paused=0;
        refresh_rate=1;
        score_font=0;
        pause_font=0;
        game_x=-1;
        game_y=-1;
        drawing_stuff=0;
        cur_frame=0;

        srand(time(0));

        for (i=0; i<top_rustic->total_players; i++)
            {
            for (j=0; j<4; j++)
                top_rustic->players[i]->direction[j]=0;
            top_rustic->players[i]->score=0;
            top_rustic->players[i]->pscore=-1;
            top_rustic->players[i]->alive=1;
            top_rustic->players[i]->lives=5;
            top_rustic->players[i]->plives=-1;
            }
        changes=0;
        special=0;

        LOCK_VARIABLE(game_counter);
        LOCK_FUNCTION(game_time_handler);
        game_counter=0;
        install_int(game_time_handler,1000/GAME_MTPS);

     //   mymidi=load_midi("canyon.mid");
     //   play_midi(mymidi,1);
        }

    game::~game()
        {
        delete score_font;
        delete pause_font;

        remove_int(game_time_handler);
       // destroy_midi(mymidi);
        }

void game::key(keyevent *e)
    {
    switch(e->k)
        {
        case KEY_F11:
            special=2;
            if (paused!=0)
                unpause();
            break;
        case KEY_F12:
            special=1;
            if (paused!=0)
                unpause();
            break;
        case KEY_ESC: 
            if (paused==0)  //so nobody quits during a good game they paused
                alive=0;
            break;
        case KEY_ENTER:
            pause("Paused");
            break;
        case KEY_SPACE:
            if (paused!=0)
                unpause();
            break;
        }
    }
          
    void game::center_draw(sfont *f, vid *g, char *s, int y)
        {
        pause_fa=0;
        pause_fd=f->MY;
        int w;
        w=f->width(s);
        if (w>pause_width) pause_width=w;
        int x=MX/2-w/2;

        mvid *cdvid = new mvid(w,f->MY);
        cdvid->fillrect(CLEAR_COLOR,0,0,w,f->MY);

        f->print_text(cdvid,s,0,0,0,CLEAR_COLOR);

        g->idomvid(cdvid,x-1,y);
        g->idomvid(cdvid,x+1,y);
        g->idomvid(cdvid,x,y-1);
        g->idomvid(cdvid,x,y+1);

        long l=cdvid->MY*cdvid->MX;
        long j;
        unsigned char *mp=cdvid->getmpointer();
        for (j=0; j<l; j++)
            if (mp[j]==0) mp[j]=15;
        
        g->idomvid(cdvid,x,y);

        delete cdvid;
        }


    int game::show_pause(vid *g)
        {
        int rt=0;
        int np=paused;
        switch(paused)
            {
            case 1:
                pause_width=0;

                pausevid=new mvid(MX,pause_font_size*2+2);
                g->getblock(pausevid->getmpointer(),
                    0,MY/2-pause_font_size-1,MX,pause_font_size*2+2);
                center_draw(pause_font,g,pause_reason,MY/2-pause_font_size);
                center_draw(pause_font,g,"press space to continue",MY/2);
                rt=1;
                np=2;
                break;
            case 2:
                break;
            case 3:
               // g->doblock(pausevid->getmpointer(),
               //     0,MY/2-pause_font_size-1,MX,pause_font_size*2+2);
                g->domvid(pausevid,0,MY/2-pause_font_size-1);
		delete pausevid;
                np=0;
                rt=1;
                break;
            }
        paused=np;
        return(rt);
        }



    int game::show_scores(vid *g)
        {
        int i,j,x,y;
        char s[80];
        j=0;
        for (i=0; i<top_rustic->total_players; i++)
            if (top_rustic->players[i]->score!=top_rustic->players[i]->pscore|
                top_rustic->players[i]->lives!=top_rustic->players[i]->plives)
                {
                x=(MX/2)*(i%2);
                y=0+(MY-font_size)*(i/2);
                g->fillrect(0,x,y,MX/2,score_font->MY);

                sprintf(s,"%d %s %ld",
                    top_rustic->players[i]->lives,
                    top_rustic->players[i]->name,
                    top_rustic->players[i]->score);
                score_font->print_text(g,s,x,y,top_rustic->players[i]->color,0);

                top_rustic->players[i]->pscore=top_rustic->players[i]->score;
                top_rustic->players[i]->plives=top_rustic->players[i]->lives;
                j++;
                }
        return(j);
        }

    int game::update(vid *myvid)
        {
        if (alive==0)
            {
            pause("Game Over");
            alive=2;
            }

        if (first_frame!=0)
            {
            myvid->fillrect(0,0,0,MX,MY);
            first_frame=0;
            }

        if (paused==0 & alive==1)
            next_turn();

        int i=0;
        vid *newvid=new svid(myvid,0,font_size,MX,MY-font_size);

        if (paused!=2)
            i+=game_update(newvid);

        delete newvid;
        i+=show_pause(myvid);
        i+=show_scores(myvid);
        cur_frame++;

       // rest((long)((float)refresh_rate*1000.0));
        long tot=(long)((float)refresh_rate*GAME_MTPS);
        int stc=10;
        if (game_counter>tot)
            {
            stc=12;
            game_counter=0;
            }
            else
            {
            while(game_counter<tot);
            game_counter-=tot;
            }
        myvid->fillrect(stc,MX-3,MY-3,3,3);

        if (alive==2 & paused==0)
            {
            if (savescores == 1)
                top_rustic->change_screen(new highscore(top_rustic,gamename));
                else
                top_rustic->change_screen(new rusticmenu(top_rustic));
            }
	
	
//	myvid->domvid(myvid,-1,0); i=1;
        return(i);
        }

          
    void game::resize()
        {
        font_size=default_font_size*MY/default_screen_y;
        font_size_x=(MX/2)/15;
        pause_font_size=default_pause_font_size*MY/default_screen_y;
        pause_font_size_x=MX/25;

        game_x=MX;
        game_y=MY-(font_size*2);

        delete score_font;
        delete pause_font;

        score_font=new graffont(RUSTIC_FONT,font_size);
        score_font->MX=font_size_x;
        pause_font=new graffont(RUSTIC_FONT,pause_font_size);
        pause_font->MX=pause_font_size_x;

        game_resize_pictures();
        }


    void game::pause(char *reason)
        {
//		paused=0; return;
        if (paused==0)
            {
            next_turn();
            int i;
            for (i=0; i<strlen(reason)+1; i++)
                pause_reason[i]=reason[i];
            paused=1;
            changes=1;
            }
        }

    void game::unpause()
        {
        paused=3;
        changes=1;
        }


    void game::start_game()
        {
        }




mvid *game::makeimage(unsigned char *img, int px, int py)
    {
    mvid *ret = new mvid(px,py);
    ret->doblock(img,0,0,px,py);
    return(ret);
    }
