#include "menu.h"
#include <string.h>

js_data joesnow1 =
    {
    "joesnow1",
    "joesnow1.grf",
    "joesnow1.lvl",
    {
     "Snow Cliff",
     "Dorzania",
     "Chinka",
     "Mamoth Hill",
     "Low Life",
     "Dome City",
     "Donisec",
     "Mover Mt.",
     "Snoidaria",
     "Tonkarna",
     "Army Base",
     "Lava Lairs",
     "Emrald Pit",
     "Glass Arch",
     "Dizona Block",
     "Questionable",
     "Diamond Tower",
     "Lava Trench",
     "Lava Doom",
     "Power Mines",
     "Secret Room"
    }
    };

js_data joesnow2=
    {
    "joesnow2",
    "joesnow2.grf",
    "joesnow2.lvl",
    {
     "Snoopy!!",
     "Vortex Pit",
     "Pizza!!!",
     "Eye Balls..",
     "Snid - Vody",
     "Amazing....",
     "Movers & Lips",
     "Wild Eights!",
     "Middle - East",
     "Tonkarna",
     "Tough Luck!",
     "Lava.",
     "Emrald Mines",
     "Diamond Pit!",
     "Not So Easy!",
     "Geyser!",
     "?",
     "Can You??",
     "$500,000,000",
     "Power Mines",
     "Secret Room"
    }
    };


    rusticmenu::rusticmenu(rustic *r)
       : component (PANEL_ENTIRE,PANEL_ENTIRE)
        {
        doit=1;
        top_rustic=r;
        }

    int rusticmenu::update(vid *onto)
        {
        char *menutext[] = {
            "Rustic Classics",
            "by Philip Hassey",
            " ",
            "1. Beast",
            "2. Tron",
            "3. Nibbles",
            "4. Centipede",
            "5. Tetris",
            "6. Pacman",
            "7. Joesnow 1",
            "8. Joesnow 2",
            "9. Digger",
            "A. Arkanoid",
            "B. Combat",
	        "C. Jewel Box",
			"E. Dirt Race",
            " ",
            "D. Defaults",
            "Q. Quit",
            "!"};
        int ret;
        int bgc=1;
        int fgc=15;
        ret=doit;
        int i;
        i=0;
        int sz=0;
        int fxl=0;
        while (menutext[i][0]!='!')
            {
            if (strlen(menutext[i])>fxl)fxl=strlen(menutext[i]);
            i++;
            }

        if (doit!=0)
            {
            onto->fillrect(bgc,0,0,MX,MY);
            int fs=MY/i;
            graffont *myfont=new graffont(RUSTIC_FONT);
            myfont->MX=MX/fxl;
            myfont->MY=fs;
            i=0;
            while (menutext[i][0]!='!')
                {
                myfont->print_text(onto,menutext[i],0,i*fs,fgc,bgc);
                i++;
                }
            delete myfont;
            }
        doit=0;
        return(ret);
        }

    void rusticmenu::key(keyevent *e)
        {
        switch(tolower(e->ch))
            {
            case '1':
                top_rustic->change_screen(new beast(top_rustic));
                break;
            case '2':
                top_rustic->change_screen(new tron(top_rustic));
                break;
            case '3':
                top_rustic->change_screen(new nibbles(top_rustic));
                break;
            case '4':
                top_rustic->change_screen(new centiped(top_rustic));
                break;
            case '5':
                top_rustic->change_screen(new tetris(top_rustic));
                break;
            case '6':
                top_rustic->change_screen(new pacman(top_rustic));
                break;
            case '7':
                top_rustic->change_screen(new joesnow(top_rustic,&joesnow1));
                break;
            case '8':
                top_rustic->change_screen(new joesnow(top_rustic,&joesnow2));
                break;
            case '9':
                top_rustic->change_screen(new digger(top_rustic));
                break;
            case 'a':
                top_rustic->change_screen(new arkanoid(top_rustic));
                break;
            case 'b':
                top_rustic->change_screen(new combat(top_rustic));
                break;
	    case 'c':
		top_rustic->change_screen(new jewel(top_rustic));
		break;
            //case 'c':
            //    top_rustic->change_screen(new joesnowi(top_rustic));
            //    break;
			case 'e':
				top_rustic->change_screen(new dirtrace(top_rustic));
				break;
            case 'd':
                top_rustic->change_screen(new rusticdefaults(top_rustic));
                break;
            case 'q':
                top_rustic->remove_me=REMOVE_NOW;
                break;
            }
        }
