#include "tron.h"

void tron::next_turn()
	{
	int x,y,i,j;
	i=0;
	for (j=0; j<top_rustic->total_players; j++)
		if (top_rustic->players[j]->alive==1)
			{
			i++;
			move_player(j);
			}

	x=0;
	if (i==0)
		{
		for (j=0; j<top_rustic->total_players; j++)
			if (top_rustic->players[j]->lives>0)
				x+=top_rustic->players[j]->lives;					
		if (x==0)
			alive=0;
			else
			newgame(1);
		}
	}

int tron::game_resize_pictures()
	{
	int x,y;

	int i;

	PX=game_x/MX;
	PY=game_y/MY;
	if (PX<1 | PY<1) return(-1);

	playfield->all_on();
		   
	ginit=1;
	return(1);
	}


tron::tron(rustic *r)
	: game(r)
	{
	gamename="Tron";
	savescores=0;
	playfield=new pfield(MX,MY);

	cur_level=0;

	PX=8;
	PY=8;

	count=0;

	refresh_rate=.1f;
	top_rustic->key_form=top_rustic->HOLD_ON;
	crash.load("bang.wav");
	newgame(1);
	}


void tron::newgame(int level)
	{
	int i,x,y;
	for (x=0; x<MX; x++)
		for (y=0; y<MY; y++)
			playfield->set(x,y,BKGR);
	for (x=0; x<MX; x++)
		{
		playfield->set(x,0,WALL);
		playfield->set(x,MY-1,WALL);
		}
	for (y=0; y<MY; y++)
		{
		playfield->set(0,y,WALL);
		playfield->set(MX-1,y,WALL);
		}

	for (i=0; i<top_rustic->total_players; i++)
		if (top_rustic->players[i]->lives>0)
			{
			top_rustic->players[i]->x=MX/4+(MX/2)*(i%2);
			top_rustic->players[i]->y=MY/4+(MY/2)*(i/2);
			top_rustic->players[i]->alive=1;
			top_rustic->players[i]->moved=1;
			top_rustic->players[i]->direction[1]=1;
			top_rustic->players[i]->calc_mxmy();
			}

	alive=1;
	cur_level++;
	char s[80];
	sprintf(s,"Round %d",cur_level);
	pause(s);
	}



int tron::game_update(vid *g)
	{
	int x,y;
	int c=0;
	int i;
	int color=-1;  int nc;
	color=-1;
		
	if (ginit==1)
		{
		for (y=0; y<MY; y++)
			for (x=0; x<MX; x++)
				if (playfield->a_get(x,y)==1)
				{
				nc=playfield->get(x,y);

				if (nc!=color)
					{
					color=nc;
					if (nc!=0 & nc!=15)
						color=top_rustic->players[nc-1]->color;
					}

				g->fillrect(color,x*PX,y*PY,PX,PY);
				playfield->a_set(x,y,0);
				c++;
				}
		}

	if (c!=0)
		return(1);

	return(0);
	}

void tron::move_player(int p)
	{
	int x=top_rustic->players[p]->x;
	int y=top_rustic->players[p]->y;
	int mx=top_rustic->players[p]->mx;
	int my=top_rustic->players[p]->my;

	int i,j,xx,yy;
	int nx,ny;

	nx=x+mx;ny=y+my;
	int r=0;

	if (playfield->get(nx,ny)!=BKGR)
		{
		top_rustic->players[p]->alive=0;
		crash.play();
			
	for (i=0; i<top_rustic->total_players; i++)
			if (top_rustic->players[i]->alive==1)
				top_rustic->players[i]->score+=25;
		}
		else
		{
		playfield->set(nx,ny,p+1);
		top_rustic->players[p]->x=nx;
		top_rustic->players[p]->y=ny;
		top_rustic->players[p]->moved=1;
		}
	}

tron::~tron()
	{
	delete playfield;
	}
