#ifndef VID_H
#define VID_H

#define CLEAR_COLOR 16

class mvid;
class vid
    {
    public:
        unsigned int MX, MY;

        vid();
        virtual void resize(int mx, int my);
        void line(int c, int x, int y, int xx, int yy);

        virtual void fillrect(unsigned char c, unsigned int x, unsigned int y, unsigned int mx, unsigned int my); 
        void clearvid();
        virtual void floodfill(unsigned char c, unsigned int x, unsigned int y);

        virtual void dopixel(unsigned char c, unsigned int x, unsigned int y);
        virtual int getpixel(unsigned int x, unsigned int y);

        virtual void doblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my);
        virtual void idoblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my);

        virtual void getblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my);

        virtual void domvid(mvid *v, unsigned int x, unsigned int y);
        virtual void idomvid(mvid *v, unsigned int x, unsigned int y);


        virtual ~vid();
    };

#include "mvid.h"

#endif
