#include "../grafedit/graflib.h"
#include "../grafedit/levellib.h"
#include "pfield.h"
#include "game.h"

class arkanoid_ball {
    public:
    int alive;
    double x,y,ax,ay;
    int speed;
    int owner;
    int t;
    int noscores;
    arkanoid_ball() { alive=0; }
    };

class arkanoid_pill {
    public:
    int x,y;
    int type;
    int alive;
    arkanoid_pill() {alive=0;}
    };

#define PILL_SLOW     0
#define PILL_LASER    1
#define PILL_EXTEND   2
#define PILL_TRIPLE   3


class arkanoid : public game
{
public:

const int max_balls = 36;
arkanoid_ball balls[max_balls];
arkanoid_pill pill;
const int PILL_IMG=17;

const int MX=13;
const int MY=19;
const int PICX=15;
const int PICY=11;
const int SC_X=(MX*PICX);
const int SC_Y=(MY*PICY);

const int screen_x=21;
const int screen_y=19;

const int ADD_X=4;
int PX,PY;


const int different_levels=25;

const int BKGR=0;
const int GOLD=6;
const int SILVER=7;
const int CSILVER=8;
const int WALL=15;

pfield *playfield;
pfield *cplayfield;

graflib *pictures;

const int PLAYER_NORM =  0;
const int PLAYER_CATCH=  1;
const int PLAYER_BIG  =  2;
const int PLAYER_LASER=  3;

levellib *level_data;
void next_turn();
int game_resize_pictures();
arkanoid(rustic *r) ;
~arkanoid();

audioclip death,bonus,ticksound,smacksound;//,beginlevel;


int cur_level;
void newgame(int level);

int game_update(vid *g);

void move_player(int p);
void kill_player(int p);

double bb_rx,bb_ry;

void bounce_ball(double ac, double as, double rc, double rs);
void move_balls();

void aset(int x, int y, int mx, int my);

void bendangle(int b, double a);
void changeangle(int b, double a);
int noscores;
};
