#include "game.h"
#include "pfield.h"
#include "../grafedit/graflib.h"

class centiped : public game
{
public:
int CVAR_centipede_length;  // more is longer
int CVAR_cetniped_speed;  // higher is slower
int CVAR_laser_freq; // higher is less freq
int CVAR_laser_speed; // higher is faster
int CVAR_laser_max;  // higher is more laser shots
int CVAR_spider_freq; // higher is less freq
int CVAR_spider_speed; // higher is slower
int CVAR_spider_max; // higher is more spiders
int CVAR_faller_freq; // higher is less freq
int CVAR_faller_speed; // higher is faster

const int total_vars=10;

void level_defaults(int cl);




const int MX=32;
const int MY=32;
const int level_size=MX*MY;

pfield *playfield;// = new pfield(MX,MY);


graflib *pictures;

int tnum;

int apfld[MX*MY];
void next_turn();

void score_enemy(int en, int bl);

int game_resize_pictures();

centiped(rustic *r);
~centiped();

audioclip livehit,deadhit,fallsnd,death;


int cur_level;

int previous_level;
   const int BKGR=0x0e;
   const int CENT_LEFT=0;
   const int CENT_RIGHT=1;
   const int SHROOM=2; // and 3 and 4
   const int PLAYER=5;
   const int SPIDER=6;
   const int FALLER=7; // and 8
   const int BLAST=0x0d;
   const int BLOCK=0x0f;
void newgame(int level);

int PX,PY;


int game_update(vid *g);

void move_player(int p);

int count_shots(int p);

int total_live_players();

void key_check(int p);

void kill_player(int p);

void check(int p);
};

