#include "../grafedit/graflib.h"
#include "../grafedit/levellib.h"
#include "pfield.h"
#include "game.h"

class combat_ball {
    public:
    int alive;
    double x,y,ax,ay;
    int speed;
    int owner;
    int t;
    combat_ball() { alive=0; }
    };


class combat : public game
{
public:

const int max_balls = MAX_PLAYERS;
combat_ball balls[max_balls];

const int MX=30;
const int MY=18;
const int PICX=8;
const int PICY=8;
const int SC_X=(MX*PICX);
const int SC_Y=(MY*PICY);

const int different_levels=5;

const int BKGR=0;
const int WALL=1;
const int PLAYER=27;

pfield *playfield;

int PX,PY;

graflib *pictures;

levellib *level_data;
const int MAX_ROTS=8 ;
mvid *player_pictures[MAX_PLAYERS][MAX_ROTS];

void next_turn();
int game_resize_pictures();
combat(rustic *r);
~combat();

audioclip death,boomsound,ticksound;

int cur_level;                    
void newgame(int level);

int game_update(vid *g);

long frame_num;
void move_player(int p);
void kill_player(int p);

double bb_rx,bb_ry;

void bounce_ball(double ac, double as, double rc, double rs);
void move_balls();

void aset(int x, int y, int mx, int my);

void bendangle(int b, double a);
void changeangle(int b, double a);
};
