#include "classes.h"

component::component(long smx, long  smy)
    {
    sMX=smx;
    sMY=smy;
    MX=0;
    MY=0;
    sPX=0;
    sPY=0;
    PX=0;
    PY=0;
    require_focus=FOCUS_UNREQUIRED;
    remove_me=REMOVE_NEVER;
    }

void component::set_location(int px, int py)
    {
    PX=px;
    PY=py;
    }

void component::set_slocation(long spx, long spy)
    {
    sPX=spx;
    sPY=spy;
    }

void component::resize(int mx, int my)
    {
    if (MX!=mx | MY!=my)
        {
        MX=mx;
        MY=my;
    if (MX!=0 & MY!=0) 
        resize();
        }
    }

void component::resize() {}

int component::update(vid *onto) { return(0); }

void component::mouse(mouseevent *e) {}

void component::key(keyevent *e) {}

component::~component()
    {
    }


// ------ double buffered component -------

dbuff_component::dbuff_component(long smx, long smy)
    : component(smx, smy)
    {
    MX=0;
    MY=0;
    }

void dbuff_component::resize(int mx, int my)
    {
    if (mx!=MX | my!=MY)
        {
        if (MX!=0 & MY!=0) delete myvid;
        if (mx!=0 & my!=0)
            {
            myvid=new mvid(mx,my);
            myvid->clearvid();
    component::resize(mx,my);
            }
        }
    }

int dbuff_component::update(vid *onto)
    {
    int chg=0;
    if (MX!=0 & MY!=0)
        {
        chg=update();
       // onto->doblock(myvid->getmpointer(),0,0,MX,MY);
        onto->domvid(myvid,0,0);
	}
    return(chg);
    }

int dbuff_component::update() { return(0); }

dbuff_component::~dbuff_component()
    {
    if (MX!=0 & MY!=0)
        delete myvid;
    }

