#include "joesnowi.h"

unsigned char jsi_image_mappings[] //= new int [2*total_things]
=
  {
 //image, mapping
 /*
  0,0,//bkgr
  1,1,//coin
  2,2,//fire
  3,3,//blck
  0,4,//start
  4,5,//mvrl
  5,6,//mvrr
  6,7,//lava
  7,7,//ltop
  8,9,//emrl
  9,3,//glss
  10,9,//dmnd
  11,5,//mvrp
  11,6,//mvrp
  0,14, //hit head thing..
  12,15,//qust
  3,0,  //block that isn't there..
  16,3, //blcjp
  13,18,//item
  14,19,//pict
  0,20, //
  15,21//warp
  */


  0,0,
  1,1,
  2,2,
  3,3,
  4,18,
  5,5,
  6,6,
  7,4


  };



void joesnowi::next_turn()
    {
    int x,y,i,j;

    i=0;

    if (special==1)
        {
        special=0;
        cur_level++;

        newgame(cur_level);
        }

    int q;

    for (j=0; j<top_rustic->total_players; j++)
        {
        if (top_rustic->players[j]->alive==1)
            {
            i++;
            move_player(j);
            }
        }

    int finished=1;
    for (y=0; y<MY; y++)
    for (x=0; x<MX; x++)
        if (playfield->get(x,y)==4) finished=0;

    if (finished==1) newgame(cur_level+1);
    }



int joesnowi::game_resize_pictures()
    {
    int x,y;

    int i;

    PX=game_x/MX;
    PY=game_y/MY;
    if (PX<1 | PY<1) return(-1);

//        PX=8;
//        PY=8;
  //  int [] img = new int[PX*PY];
    unsigned char *img=new unsigned char [PX*PY];
    int mx,my; int j,k;
    if (ginit==1)
        {
        for (i=0; i<max_players; i++) delete player_pictures[i];
        }

    pictures->resize(PX,PY);


        int xx,yy;
        int c;
        int ca,cs;






            int z;

    for (i=0; i<max_players; i++)
        {
        for (y=0; y<PY; y++)
            for (x=0; x<PX; x++)
                if (sqrt((x-PX/2)*(x-PX/2)+
                    (y-PY/2)*(y-PY/2))<(PX/2))
                    img[y*PX+x]=top_rustic->players[i]->color;
                    else
                    img[y*PX+x]=CLEAR_COLOR;
        player_pictures[i]=makeimage(img,PX,PY);
        }

    playfield->all_on();
    delete [] img;

    ginit=1;
    return(1);
    }


joesnowi::joesnowi(rustic *r)
    : game(r)
    {

    gamename="joesnowi";


    playfield = new pfield(MX,MY);


PX=8;
PY=8;

//Image [] pictures = new Image[total_images];
pictures=new graflib("joesnowi.grf");


    refresh_rate=.2f/(float)div_thing;
    top_rustic->key_form=top_rustic->LET_GO;

    newgame(0);
    start_game();
    }

joesnowi::~joesnowi()
    {
    delete playfield;
    delete pictures;
    int i;
        for (i=0; i<max_players; i++) delete player_pictures[i];
    }

int joesnowi::pplayfield_get(int p, int x,int y)
    {
    int px,py;
    int pxd,pyd;
    px=top_rustic->players[p]->x;
    py=top_rustic->players[p]->y;
    pxd=px/div_thing;
    pyd=py/div_thing;

    int dx,dy;
    dx=x-pxd;
    dy=y-pyd;

    int tdx=0,tdy=0;
    if (dx<0) {tdx=-div_thing/2-1;dx++;}
    if (dy<0) {tdy=-div_thing/2-1;dy++;}
    if (dx>0) {tdx=div_thing/2;dx--;}
    if (dy>0) {tdy=div_thing/2;dy--;}
    tdx+=dx*div_thing;
    tdy+=dy*div_thing;

    x=px+tdx+div_thing/2;
    y=py+tdy+div_thing/2;
    x/=div_thing;
    y/=div_thing;
    
    return(playfield->get(x,y));
    }

void joesnowi::pplayfield_set(int p, int x, int y, int c)
    {
    int px,py;
    int pxd,pyd;
    px=top_rustic->players[p]->x;
    py=top_rustic->players[p]->y;
    pxd=px/div_thing;
    pyd=py/div_thing;

    int dx,dy;
    dx=x-pxd;
    dy=y-pyd;

    int tdx=0,tdy=0;
    if (dx<0) {tdx=-div_thing/2-1;dx++;}
    if (dy<0) {tdy=-div_thing/2-1;dy++;}
    if (dx>0) {tdx=div_thing/2;dx--;}
    if (dy>0) {tdy=div_thing/2;dy--;}
    tdx+=dx*div_thing;
    tdy+=dy*div_thing;

    x=px+tdx+div_thing/2;
    y=py+tdy+div_thing/2;
    x/=div_thing;
    y/=div_thing;
    
    playfield->set(x,y,c);
    }

void joesnowi::newgame(int level)
    {
    int i,x,y;


    int starter=7;
    cur_level=level;
    srand(cur_level);

    int sx,sy;
    sx=1;
    sy=2;

    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            {
            playfield->set(x,y,rand()%4);
            }
    playfield->set(1+(rand()%(MX-1)),1+(rand()%(MY-1)),4);

    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            {
            if (playfield->get(x,y)==starter)
                    {
                    sx=x;sy=y;
                    playfield->set(x,y,0);
                    }
            }

   for (x=0; x<MX; x++)
        {
        playfield->set(x,0,3);
        playfield->set(x,MY-1,3);
        }
   for (y=0; y<MY; y++)
        {
        playfield->set(0,y,3);
        playfield->set(MX-1,y,3);
        }

    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {
 //       top_rustic->players[i]->x=MX/4+(MX/2)*(i%2);
 //       top_rustic->players[i]->y=MY/4+(MY/2)*(i/2);
        top_rustic->players[i]->x=sx*div_thing; 
        top_rustic->players[i]->y=sy*div_thing;

        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->j=0;
        top_rustic->players[i]->r=0;
        top_rustic->players[i]->jl=4*div_thing+1;
 //       playfield->set(top_rustic->players[i]->x,top_rustic->players[i]->y,BKGR);
        }

    alive=1;
    //pause("Level " + (cur_level+1) + " -  " + joesnowi_data.level_names[cur_level]);
    char s[80];
    sprintf (s,"Level %d",cur_level+1);
    pause(s);
    }



int joesnowi::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;

    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {
            g->domvid(pictures->imageint(jsi_image_mappings[playfield->get(x,y)*2]),
                x*PX,y*PY);
            playfield->a_set(x,y,0);
            c++;
            }

    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->alive==1)
            if (top_rustic->players[i]->moved==1)
                {
                top_rustic->players[i]->moved=0;
                g->idomvid(player_pictures[i],top_rustic->players[i]->x*PX/div_thing,
                top_rustic->players[i]->y*PY/div_thing);
                c++;
                }
    }

    if (c!=0)
        return(1);

    return(0);
    }
void joesnowi::move_player(int p)
    {
    int x=top_rustic->players[p]->x;
    int y=top_rustic->players[p]->y;
 //   int mx=top_rustic->players[p]->mx;
  //  int my=top_rustic->players[p]->my;


    /*

    int g=0;


            if(check(p) == 1){g = 1;}
            key_check(p);
            if (check(p) == 1){g = 1;}
            jump_zip_check(p);
            if (check(p) == 1){g = 1;}
            jump_one_check(p);
            if (check(p) == 1){g = 1;}
            mover_check(p);
            if (check(p) == 1){g = 1;}
   */

    check(p);
    key_check(p);
    check(p);
    jump_zip_check(p);
    jump_one_check(p);
    check(p);
    mover_check(p);
    check(p);

       int j;
    if (x!=top_rustic->players[p]->x | y!=top_rustic->players[p]->y)
        {

        for (j=0; j<top_rustic->total_players; j++)
            top_rustic->players[j]->moved=1;

        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));

        x-=div_thing-1;
        y+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        x+=div_thing-1;
        playfield->set(x/div_thing,y/div_thing,playfield->get(x/div_thing,y/div_thing));
        }

/*
    int i,j,xx,yy;
    int nx,ny;

    nx=x+mx;ny=y+my;

    if (mx==0 & my==0) return;

    int r=0;

    switch(playfield->get(ny,nx))
        {
        case WALL:
            r=1;
            break;
        case BEAST:
            top_rustic->players[p]->alive=0;
            top_rustic->players[p]->lives--;
            break;
        case BKGR:
            break;
        case BLOCK:
            if (push_blocks(p,x,y,mx,my)==0)
                r=1;
            break;
        }

    if (r==1) return;

    playfield->set(x,y,BKGR);
    playfield->set(nx,ny,BKGR);
    top_rustic->players[p]->x=nx;
    top_rustic->players[p]->y=ny;
    top_rustic->players[p]->moved=1;
    }                         */
}

int joesnowi::am(int x)
{
return(jsi_image_mappings[x*2+1]);
}

void joesnowi::check_question(int p)
  {
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;
  int j=top_rustic->players[p]->j;
  int r=top_rustic->players[p]->r;
  int jl=top_rustic->players[p]->jl;

  int o = 0;
  int m = 1;
  int t = y;

  if (am(pplayfield_get(p,x,y-1)) == 15 | am(pplayfield_get(p,x,y-1)) == 17)
{
t=t-1;
while (o == 0)
   {
   if (am(pplayfield_get(p,x,t-m)) == 0)
  {switch (am(pplayfield_get(p,x,y-1)))
	    {
	    case 15:
     pplayfield_set(p,x,t-m,1);break;
	    case 17:
     pplayfield_set(p,x,t-m,2);break;
	    }
	  }
	  else{o = 1;
  if (am(pplayfield_get(p,x,t-m)) == 14) {pplayfield_set(p,x,t-m,17);
     top_rustic->players[p]->score+=50;


  j=0;
  r=0;
  }}
   m = m+1;
   }
  //  scrn [y-1][x] = 3;
pplayfield_set(p,x,y-1,17);
//    _putimage (x*8,(y-1)*8,blcjp,_GPSET);
}

  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->r=r;
  }


void joesnowi::jump_one_check(int p)
  {
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;
  int j=top_rustic->players[p]->j;
  int r=top_rustic->players[p]->r;
  int jl=top_rustic->players[p]->jl;

  int i;
  if (j == 1)
{
check_question(p);
if (am(pplayfield_get(p,x,y-1)) == 14) {pplayfield_set(p,x,y-1,17);//score=score+50;
  //    _setactivepage(0);_putimage(x*8,(y-1)*8,blcjp,_GPSET);
  //scr=scr+50;
  top_rustic->players[p]->score+=50;

  j=0;r=0;}
if (am(pplayfield_get(p,x,y-1)) == 20) {pplayfield_set(p,x,y-1,21);//score=score+50;
 //     _setactivepage(0);_putimage(x*8,(y-1)*8,warpp,_GPSET);
top_rustic->players[p]->score+=50;
  //scr=scr+50;
  j=0;r=0;}
if (j == 1)
  {
  if (am(pplayfield_get(p,x,y-1)) == 3 | am(pplayfield_get(p,x,y-1)) == 5 |
  am(pplayfield_get(p,x,y-1)) == 6 | am(pplayfield_get(p,x,y-1)) == 15){j=0;r=0;}else{
  y = y-1;
  r = r+1;
  if (r == jl){j=0;r=0;}}
  }
}
  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->r=r;
  }

void joesnowi::jump_zip_check(int p)
  {
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;
  int j=top_rustic->players[p]->j;
  int r=top_rustic->players[p]->r;
  int jl=top_rustic->players[p]->jl;


  int i;
  if (j == 0)
{

if (am(pplayfield_get(p,x,y+1)) != 3 & am(pplayfield_get(p,x,y+1)) != 5
  & am(pplayfield_get(p,x,y+1)) != 6 & am(pplayfield_get(p,x,y+1)) != 15 &  am(pplayfield_get(p,x,y+1)) != 17 )  {
  y = y+1; }
}
  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->r=r;
  }

void joesnowi::key_check(int p)
  {
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;
  int j=top_rustic->players[p]->j;
  int r=top_rustic->players[p]->r;
  int jl=top_rustic->players[p]->jl;


  int i;

  int k;
  k=-1;
/*
  for (i=0; i<4; i++)
if (top_rustic->players[p]->direction[i]==1)
    k=i;*/
//  k=top_rustic->players[p]->cur_direction;

 // switch (k)
  //  {
//    case player.RIGHT:
if (top_rustic->players[p]->direction[PLAYER_RIGHT]==1) {
    if(am(pplayfield_get(p,x+1,y)) != 3 & am(pplayfield_get(p,x+1,y)) != 5 &
am(pplayfield_get(p,x+1,y)) != 6 & am(pplayfield_get(p,x+1,y)) != 15& am(pplayfield_get(p,x+1,y)) != 17){
   //  for (i = 1; i<=8; i++){wait(2500);
   //  drop (buf,buf1,x*8+i,y*8,(x*8)+7+i,(y*8)+7);}
 x = x+1;}
 }
 //     break;
if (top_rustic->players[p]->direction[PLAYER_LEFT]==1) {
//    case player.LEFT:
if(am(pplayfield_get(p,x-1,y)) != 3 & am(pplayfield_get(p,x-1,y)) != 5 &
am(pplayfield_get(p,x-1,y)) != 6 & am(pplayfield_get(p,x-1,y)) != 15& am(pplayfield_get(p,x-1,y)) != 17){
 //    for (i = 1; i<=8; i++){wait(2500);
  //   drop (buf,buf1,x*8-i,y*8,(x*8)+7-i,(y*8)+7);}
  x = x-1;}
  }//   break;
if (top_rustic->players[p]->direction[PLAYER_UP]==1) {
//    case player.UP:
//        top_rustic->players[p]->direction[player.UP]=0;
    if (am(pplayfield_get(p,x,y-1)) != 3 & am(pplayfield_get(p,x,y-1)) != 5
& am(pplayfield_get(p,x,y-1)) != 6)
{if (am(pplayfield_get(p,x,y+1)) == 3
| am(pplayfield_get(p,x,y+1)) == 5 | am(pplayfield_get(p,x,y+1)) == 6 | am(pplayfield_get(p,x,y+1)) == 15
| am(pplayfield_get(p,x,y+1)) == 17)
{j = 1;}}
}//break;
//    case QUIT: check_scores(1);_setvideomode(_TEXTC80);exit(1); break;
if (top_rustic->players[p]->direction[PLAYER_DOWN]==1) {
//    case player.DOWN:
  //      top_rustic->players[p]->direction[player.UP]=0;
    j = 0;r = 0;
    }//break;
//    case HELP: help();break;
 //   case SCORES: check_scores(0);
//    default:break;
  //  }
  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->r=r;
  //return (0);
  }


void joesnowi::check(int p)
  {
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;
  int j=top_rustic->players[p]->j;
  int r=top_rustic->players[p]->r;
  int jl=top_rustic->players[p]->jl;
  int score=top_rustic->players[p]->score;


  if (am(pplayfield_get(p,x,y)) ==  1) {score=score+100;pplayfield_set(p,x,y,0);}
  if (am(pplayfield_get(p,x,y)) ==  2) {score=score-200;pplayfield_set(p,x,y,0);}
  if (am(pplayfield_get(p,x,y)) ==  7) {score=score-500;pplayfield_set(p,x,y,0);}
  if (am(pplayfield_get(p,x,y)) ==  9) {score=score+1000;pplayfield_set(p,x,y,0);}
  if (am(pplayfield_get(p,x,y)) == 18) {score=score+10000;
pplayfield_set(p,x,y,0);}
  if (am(pplayfield_get(p,x,y)) == 21) {score=score+5000;}//warp thingie..
//  if (score <= 0){check_scores(0);

  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->r=r;
  top_rustic->players[p]->score=score;

//  _setvideomode (_TEXTC80);
 // printf ("GAME OVER!\nSCORE = %d",score);exit(1);}
 // return(0);
  }

void joesnowi::mover_check(int p)
  {
  int i;
  int x=top_rustic->players[p]->x/div_thing;
  int y=top_rustic->players[p]->y/div_thing;
  int j=top_rustic->players[p]->j;
  int r=top_rustic->players[p]->r;
  int jl=top_rustic->players[p]->jl;


  if (am(pplayfield_get(p,x,y+1)) == 5){x = x-1;
 if (am(pplayfield_get(p,x,y)) != 3 & am(pplayfield_get(p,x,y)) != 5
 & am(pplayfield_get(p,x,y)) != 6 & am(pplayfield_get(p,x,y)) != 15 ) {
 x = x+1;
 //    for (i = 1; i<=8; i++){wait(2500);
  //   drop (buf,buf1,x*8-i,y*8,(x*8)+7-i,(y*8)+7);}
  x = x-1;}else{x = x+1;}}

  if (am(pplayfield_get(p,x,y+1)) == 6){x = x+1;
 if (am(pplayfield_get(p,x,y)) != 3 & am(pplayfield_get(p,x,y)) != 5
 & am(pplayfield_get(p,x,y)) != 6 & am(pplayfield_get(p,x,y)) != 15) {
 x = x-1;
 //for (i = 1; i<=8; i++){wait(2500);
// drop (buf,buf1,x*8+i,y*8,(x*8)+7+i,(y*8)+7);}
 x = x+1;}else{x = x-1;}}
  top_rustic->players[p]->x+=(x-top_rustic->players[p]->x/div_thing);
  top_rustic->players[p]->y+=(y-top_rustic->players[p]->y/div_thing);
  top_rustic->players[p]->j=j;
  top_rustic->players[p]->r=r;
  }
