#include "dirtrace.h"
#include <math.h>


#define PLAYER_SPEED 4 //2

void dirtrace::next_turn()
	{
	int x,y,i,j;

	if (special==1)
		{
		special=0;
		newgame(cur_level+1);
		}

	i=0;

	int q;

	frame_num++;
	for (j=0; j<top_rustic->total_players; j++)
		{
		if (top_rustic->players[j]->alive==1)
			{
			i++;
			move_player(j);
			}
		}

	if (i==0)
		{
		x=0;
		for (j=0; j<top_rustic->total_players; j++)
			if (top_rustic->players[j]->lives>0)
				x+=top_rustic->players[j]->lives;					
		if (x==0)
			alive=0;
			else
			newgame(cur_level+1);
		}
	}


int dirtrace::game_resize_pictures()
	{
	int x,y;

	int i;int s=32;

	PX=(int)(game_x/MX);
	PY=(int)(game_y/MY);
	if (PX<1 | PY<1) return(-1);


	int mx,my,j;
	mx=pictures->myimages[0]->data[0];
	my=pictures->myimages[0]->data[1];

	pictures->resize(s,s);

	unsigned char *img = new unsigned char[PX*PY];

	if (ginit==1)
		{
		for (i=0; i<max_players; i++)
		for (j=0; j<MAX_ROTS; j++)
			delete player_pictures[i][j];
		}

	for (i=0; i<max_players; i++)
		for (j=0; j<MAX_ROTS; j++)
		{
		mvid *m=pictures->imageint(PLAYER+j);
		int clr;
		int nx,ny;
		int xx,yy;
		int c;
		for (y=0; y<PY; y++)
			for (x=0; x<PX; x++)
				{
				//clr=m->getpixel(x,y);
				clr=CLEAR_COLOR;
				for (yy=y*s/PY; yy<(y+1)*s/PY; yy++)
					for (xx=x*s/PX; xx<(x+1)*s/PX; xx++)
						{
						c=m->getpixel(xx,yy);
						if (c!=CLEAR_COLOR & clr!=14)
							clr=c;
						}
				
			  //  if (clr==0) clr=CLEAR_COLOR;
				if (clr==9)
					clr=top_rustic->players[i]->color;
					else
					if (clr==14 & (i==2 | i==3)) clr=9;
				img[y*PX+x]=clr;
				}
		player_pictures[i][j]=makeimage(img,PX,PY);
		}

	pictures->resize(PX,PY);

	playfield->all_on();
	delete [] img;
	ginit=1;
	return(1);
	}


dirtrace::dirtrace(rustic *r)
	: game(r)
	{
	gamename="DirtRace";

	if (top_rustic->total_players==1)
		savescores=1;
		else
		savescores=0;

	playfield = new pfield(MX,MY);
	playfield->defret=WALL;

	pictures = new graflib("dirtrace.grf");
	refresh_rate=0.035;

	top_rustic->key_form=top_rustic->LET_GO;

	level_data = new levellib("dirtrace.lvl");

	cur_level=-1;
	lapsound.load("zoom.wav");
	winsound.load("trumpet.wav");
	newgame(0);
	}

dirtrace::~dirtrace()
	{
	delete playfield;
	delete level_data;
	delete pictures;

	int i,j;
	for (i=0; i<max_players; i++)
		for (j=0; j<MAX_ROTS; j++)
			delete player_pictures[i][j];
	}


void dirtrace::newgame(int level)
	{
	int i,x,y;
	
	int newlev=0;
	if (cur_level!=level) newlev=1;

	cur_level=level;

	i=1;
	if (top_rustic->total_players==1)
		if (cur_level < different_levels)
			{
		//	if (special==0)
			if (cur_level==0) top_rustic->players[0]->score+=500;
			}
			else
			{
			i=0;
			alive=0;
			}

	if (i)
	{
	int cur_screen;
		cur_screen=cur_level%different_levels;

	unsigned char c;


	int cp=0;
	for (y=0; y<MY; y++)
		for (x=0; x<MX; x++)
			{
			c=level_data->mylevels[cur_screen]->get(x,y);

			switch (c)
				{
				case STARTER:
					top_rustic->players[cp]->dbl_x=x*PICX+(PICX/2)+1;
					top_rustic->players[cp]->dbl_y=y*PICY+(PICY/2);
					top_rustic->players[cp]->x=x*PICX+(PICX/2)+1;
					top_rustic->players[cp]->y=y*PICY+(PICY/2);
					top_rustic->players[cp]->j=0;//(i%2)*4;
					cp++;
					break;
				case STARTER2:
					top_rustic->players[cp]->dbl_x=x*PICX+(PICX/2)+1;
					top_rustic->players[cp]->dbl_y=y*PICY+(PICY/2);
					top_rustic->players[cp]->x=x*PICX+(PICX/2)+1;
					top_rustic->players[cp]->y=y*PICY+(PICY/2);
					top_rustic->players[cp]->j=2;//(i%2)*4;
					cp++;
					break;
				
				}
				
			if (newlev==1)
			   playfield->set(x,y,c);
			}


	for (i=0; i<top_rustic->total_players; i++)
		if (top_rustic->players[i]->lives>0)
		{
		top_rustic->players[i]->moved=1;
		top_rustic->players[i]->alive=1;
		top_rustic->players[i]->direction[PLAYER_UP]=0;
		top_rustic->players[i]->direction[PLAYER_DOWN]=0;
		top_rustic->players[i]->direction[PLAYER_LEFT]=0;
		top_rustic->players[i]->direction[PLAYER_RIGHT]=0;
		top_rustic->players[i]->mx=0;
		top_rustic->players[i]->my=0;
		top_rustic->players[i]->p=0;
		for (x=0; x<totalchecks; x++) checks[i][x]=0;
		}
		else
		top_rustic->players[i]->alive=0;
	   

	alive=1;
	char s[80];
	sprintf(s,"Round %d",cur_level+1);
	pause(s);
	}
	}



#define ARKX(x) (int)(((x)*PX)/PICX)
#define ARKY(y) (int)(((y)*PY)/PICY)

int dirtrace::game_update(vid *g)
	{
	int x,y;
	int c=0;
	int i;



	if (ginit==1)
	{
	for (y=0; y<MY; y++)
		for (x=0; x<MX; x++)
			if (playfield->a_get(x,y)==1)
			{
			i=playfield->get(x,y);
			if (i>=CHECKER & i<(CHECKER+totalchecks)) i=BKGR;
			g->domvid(
				pictures->imageint(i),
				ARKX(x*PICX),ARKY(y*PICY));
			playfield->a_set(x,y,0);
			c++;
			}

	for (i=0; i<top_rustic->total_players; i++)
		if (top_rustic->players[i]->alive==1)
				{
				top_rustic->players[i]->moved=0;

				g->idomvid(
					player_pictures[i][top_rustic->players[i]->j],
					ARKX(top_rustic->players[i]->x-(PICX/2)),
					ARKY(top_rustic->players[i]->y-(PICY/2)));

				aset(top_rustic->players[i]->x-(PICX/2),
					 top_rustic->players[i]->y-(PICY/2),
					 PICX,PICY);

				c++;
				}
	}

	if (c!=0)
		return(1);

	return(0);
	}

void dirtrace::aset(int x, int y, int mx, int my)
	{
	playfield->a_set((x+0)/PICX,(y+0)/PICY,1);
	playfield->a_set((x+0)/PICX,(y+my)/PICY,1);
	playfield->a_set((x+mx)/PICX,(y+0)/PICY,1);
	playfield->a_set((x+mx)/PICX,(y+my)/PICY,1);
	}

int dirtrace::iswall(int x, int y)
	{
	int r=0;
	int px=x%PICX;
	int py=y%PICY;
	switch(playfield->get(x/PICX,y/PICY))
		{
		case WALL:
			r=1;
			break;
		case 2:
			if ((py+1)>px) r=1;
			break;
		case 3: 
			if ((((PICY-1)-py)+1)>px) r=1;
			break;
		case 4:
			if (py<(px+1)) r=1;
			break;
		case 5:
			if (((PICY-1)-py)<(px+1)) r=1;
			break;
		}
	return(r);
	}

void dirtrace::move_player(int p)
	{
	double x=top_rustic->players[p]->dbl_x;
	double y=top_rustic->players[p]->dbl_y;
	int j=top_rustic->players[p]->j;
	int moved=0;
	char js[3][3] = {
		3,2,1,
		4,0,0,
		5,6,7 };

	/*
	if ((frame_num%5)==0 & top_rustic->players[p]->mx!=0)
		{
		top_rustic->players[p]->moved=1;
		j+=-top_rustic->players[p]->mx;
		if (j==-1) j=MAX_ROTS-1;
		if (j==MAX_ROTS) j=0;
		}
	*/
	if (top_rustic->players[p]->mx != 0 |
		top_rustic->players[p]->my != 0)
		{
		moved=1;
		j=js[top_rustic->players[p]->my+1][top_rustic->players[p]->mx+1];
		}

	double cs,sn;

	cs=cos(PI*(-(double)j)/(double)4);
	sn=sin(PI*(-(double)j)/(double)4);
  //  if (top_rustic->players[p]->direction[PLAYER_UP])
  	if (moved)
		{
		top_rustic->players[p]->moved=1;

		double mx,my;
		mx=cs*PLAYER_SPEED;
		my=sn*PLAYER_SPEED;
		if (-0.1 < mx & mx < 0.1) mx=0;
		if (-0.1 < my & my < 0.1) my=0;

		double cx,cy;
		cx=x;
		cy=y;
		
		int k;
		int i=playfield->get((int)x/PICX,(int)y/PICY);

		if (i>=WATER & i<(WATER+5)) {mx/=3; my/=3;}
		
		if (i>=CHECKER & i<(CHECKER+totalchecks))
			{
			//death.play();
			k=1;
			if (i>CHECKER)
				k=checks[p][(i-1)-CHECKER];
		
			if (k)
				checks[p][i-CHECKER]=1;
			}
		if (i==STARTER | i==STARTER2)
			{
			i=1;
			for (k=0; k<totalchecks; k++) i*=checks[p][k];
			if (i)
				{
				top_rustic->players[p]->p++;
				for (k=0; k<totalchecks; k++) checks[p][k]=0;
				if (top_rustic->players[p]->p==LAPS)
					{
					top_rustic->players[p]->alive=0;
					for (k=0; k<top_rustic->total_players; k++)
						if (top_rustic->players[k]->alive!=0)
							top_rustic->players[p]->score+=100;
					winsound.play();
					if (top_rustic->total_players==1)
						top_rustic->players[0]->score+=500;
					}
					else
					{
					lapsound.play();
					if (top_rustic->total_players==1)
						top_rustic->players[0]->score+=500;
					}
				}
			}

	   	if (!iswall((int)(cx+mx),(int)(cy+my)))
		   	{
			x+=mx; y+=my;
			}

		/*	
			else 
			if (mx !=0 & !iswall((int)(cx+mx),(int)cy))
		  		x+=mx/2;  //slows them down when hitting walls
			else
			if (my != 0 & !iswall((int)cx,(int)(cy+my)))			
				y+=my/2;  //slows when walls..
			else 
			{
		//	lapsound.play();
			double dirs[4][2] = { 1,0,-1,0,0,1,0,-1 };
			for (i=0; i<4; i++)
				if (!iswall((int)(cx+mx+(dirs[i][0]*my)),
							(int)(cy+my+(dirs[i][1]*mx))))
					{
				//	winsound.play();
					x+=(mx+(dirs[i][0]*my))/2;
					y+=(my+(dirs[i][1]*mx))/2;
					i=4;
					}
			}
		*/
		}

	
	if (top_rustic->total_players==1)
		if (top_rustic->players[p]->score!=0)
			top_rustic->players[p]->score--;
	
	top_rustic->players[p]->x=(int)x;
	top_rustic->players[p]->y=(int)y;
	top_rustic->players[p]->dbl_x=x;
	top_rustic->players[p]->dbl_y=y;
	top_rustic->players[p]->j=j;
	}


