#include "../graflib/graflib.h"
#include "../graflib/levellib.h"
#include "pfield.h"
#include "game.h"

class dirtrace : public game
{
public:

static const int different_levels=8;

static const int LAPS=3;
static const int totalchecks=3;
unsigned char checks[MAX_PLAYERS][totalchecks];

static const int MX=40;
static const int MY=24;
static const int PICX=8;
static const int PICY=8;
static const int SC_X=(MX*PICX);
static const int SC_Y=(MY*PICY);


static const int BKGR=0;
static const int WALL=1;
static const int STARTER=6;
static const int CHECKER=7;
static const int PLAYER=27;
static const int WATER=10;
static const int STARTER2=15;

pfield *playfield;

int PX,PY;

graflib *pictures;

levellib *level_data;
static const int MAX_ROTS=8 ;
mvid *player_pictures[MAX_PLAYERS][MAX_ROTS];

void next_turn();
int game_resize_pictures();
dirtrace(rustic *r);
~dirtrace();

audioclip lapsound,winsound;

int cur_level;					
void newgame(int level);

int game_update(vid *g);

long frame_num;
void move_player(int p);

int iswall(int x, int y);

void aset(int x,int y, int mx, int my);
};

