#include "jewel.h"

void jewel::next_turn()
    {
    int x,y,i,j;

    if (count==nxt)
        if (refresh_rate>.02f) // due to "i_love_bill" timer limitation
            {
            refresh_rate-=.01f;
            add_next();
            }

    i=0;
    for (j=0; j<top_rustic->total_players; j++)
        if (top_rustic->players[j]->alive==1)
            {
            i++;
            move_player(j);
            }

    x=0;
    if (i==0)
        {
        for (j=0; j<top_rustic->total_players; j++)
            if (top_rustic->players[j]->lives>0)
                x+=top_rustic->players[j]->lives;                    
        if (x==0)
            alive=0;
            else
            newgame(1);
        }

    count++;
    }


int jewel::game_resize_pictures()
    {
    int x,y;

    int i;

    PX=game_x/MX;
    PY=game_y/MY;
    if (PX<1 | PY<1) return(-1);

    playfield->all_on();
    pictures->resize(PX,PY);
    
    ginit=1;
    return(1);
    }


jewel::jewel(rustic *r)
    : game(r)
    {
    gamename="Jewel";
    fX=7;
  //  MX=1+((fX+1)*top_rustic->max_players);
    MX=32;
    MY=15;
    count=1;
    nxt=0;

    playfield=new pfield(MX,MY);

    refresh_rate=.1f;
    top_rustic->key_form=top_rustic->HIT_ON;
    rotate.load("doy.wav");
    drop.load("tick.wav");
    line.load("bang.wav");
    pictures=new graflib("jewel.grf");
    newgame(1);
    }

jewel::~jewel()
    {
    delete pictures;
    delete playfield;
    }

void jewel::add_next()
    {
    nxt+=(int)(((float)1.0/refresh_rate)*20);
    }


void jewel::newgame(int level)
    {
    int i,x,y;
    count=1;
    refresh_rate=.1f;
    nxt=0;
    add_next();
    for (x=0; x<MX; x++)
        for (y=0; y<MY; y++)
            playfield->set(x,y,BKGR);
    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {

        top_rustic->players[i]->y=0;
       //.. top_rustic->players[i]->p=rand()%numpieces;
       // top_rustic->players[i]->j=rand()%4;
	for (y=0; y<3; y++) player_piece[i][y]=1+(rand()%numjewels);
	top_rustic->players[i]->r=1+i*(fX+1)+(MX/2-((fX+1)*top_rustic->total_players)/2);
        top_rustic->players[i]->x=top_rustic->players[i]->r+fX/2-1;
        for (x=0; x<fX+1; x++)
            playfield->set(top_rustic->players[i]->r-1+x,MY-1,WALL+i);
        for (y=0; y<MY; y++)
            {
            playfield->set(top_rustic->players[i]->r-1,y,WALL+i);
            playfield->set(top_rustic->players[i]->r+fX-1,y,WALL+i);
            }
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->calc_mxmy();
        }

    alive=1;
    pause("Get Ready");
    }



int jewel::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;
    int color=-1; 
    
    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {
            color=playfield->get(x,y);
	    if (color <= numjewels+1)
	    {
		    g->domvid(pictures->imageint(color),x*PX,y*PY);
	    }
	    else
	    {
		    if (color!=WHITE)
			    color=top_rustic->players[color-WALL]->color;
		    g->fillrect(color,x*PX,y*PY,PX,PY);
	    }
	    playfield->a_set(x,y,0);
            c++;
            }
    }

    if (c!=0)
        return(1);

    return(0);
    }

void jewel::move_player(int p)
    {
    int np=0;
    int x=top_rustic->players[p]->x;
    int y=top_rustic->players[p]->y;
    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;

    int i,j,xx,yy;
    int nx,ny;

    nx=x+mx;ny=y+my;

    int r=0;


    int m,n;

        for (n=0; n<3; n++)
                playfield->set(top_rustic->players[p]->x,n+top_rustic->players[p]->y,0);


	gravity(p);

	
    if (top_rustic->players[p]->direction[PLAYER_UP]==1)
        {
	m=player_piece[p][2];
	player_piece[p][2]=player_piece[p][1];
	player_piece[p][1]=player_piece[p][0];
	player_piece[p][0]=m;
        rotate.play();
        top_rustic->players[p]->direction[PLAYER_UP]=0;
        }

    top_rustic->players[p]->x+=mx;
    top_rustic->players[p]->direction[PLAYER_LEFT]=0;
    top_rustic->players[p]->direction[PLAYER_RIGHT]=0;

    if (checkpiece(p)!=0)
        top_rustic->players[p]->x-=mx;

    if (top_rustic->players[p]->direction[PLAYER_DOWN]==1)
        {
        //top_rustic->players[p]->y++;
        //if (checkpiece(p)!=0)
         //   {
	while(checkpiece(p)==0) top_rustic->players[p]->y++;
            top_rustic->players[p]->y--;
            np=1;
          //  }
        }

    if ((count%8)==0)
        {
        top_rustic->players[p]->y++;
        if (checkpiece(p)!=0)
            {
            top_rustic->players[p]->y--;
            np=1;
            }
        }


    blastjewels(p);
    
        for (n=0; n<3; n++)
                playfield->set(top_rustic->players[p]->x,n+top_rustic->players[p]->y,player_piece[p][n]);
              
    if (np==1) {
	    if (player_piece[p][0]==(numjewels+1))
		    {
	  	    i=playfield->get(top_rustic->players[p]->x,top_rustic->players[p]->y+3);
		    for (y=0; y<MY-1; y++)
			    for (x=top_rustic->players[p]->r; x<fX+top_rustic->players[p]->r-1; x++)
				    if (playfield->get(x,y)==i |
				        playfield->get(x,y)==(numjewels+1))
				    {
					    playfield->set(x,y,WHITE);
					    top_rustic->players[p]->score+=10;
				    }
		    line.play(); //gravity(p);
		    }
	   	    
	    newpiece(p); drop.play(); }

    }

int jewel::checkpiece(int p)
    {
    int i=0;
    int m,n;
        for (n=0; n<3; n++)
		if (playfield->get(top_rustic->players[p]->x,n+top_rustic->players[p]->y)!=WHITE)
			i+=playfield->get(top_rustic->players[p]->x,n+top_rustic->players[p]->y);
	
    return(i);
    }

void jewel::newpiece(int p)
    {
    if (top_rustic->players[p]->y==0)
        {
        top_rustic->players[p]->alive=0;
        top_rustic->players[p]->lives--;
        }

        top_rustic->players[p]->y=0;
        top_rustic->players[p]->x=top_rustic->players[p]->r+fX/2-1;
int m;
if ((rand()%25)==0)
{for (m=0; m<3; m++)
	player_piece[p][m]=1+numjewels;
}
else
{
for (m=0; m<3; m++)
	player_piece[p][m]=1+(rand()%numjewels);
}
	
blastjewels(p);
//    top_rustic->players[p]->score+=10;
}

void jewel::blastjewels(int p)
{
	int m;
    int x,y,i,j,k,q,d,done;int a,b,c;
    int dirs[4][2] = { 1,0,0,1,1,1,-1,1 };

   pfield *blasted = new pfield(MX,MY);
    
    q=1;
    done=0;

    
//    while(!done)
    {
	done=1;
	 
        for (y=0; y<MY-1; y++)
        {
        i=0;
        for (x=top_rustic->players[p]->r; x<top_rustic->players[p]->r+fX; x++)
            {
            for (d=0; d<4; d++)
                {
                a=playfield->get(x+dirs[d][0]*0,y+dirs[d][1]*0);
                b=playfield->get(x+dirs[d][0]*1,y+dirs[d][1]*1);
                c=playfield->get(x+dirs[d][0]*2,y+dirs[d][1]*2);
		if (a!=BKGR & a<=numjewels & a==b & b==c)
                    {
                    line.play();
                    done=0;
                    for (j=0; 
			playfield->get(x+dirs[d][0]*j,y+dirs[d][1]*j)==a; j++)
		    {	    
                  //  top_rustic->players[p]->score+=10*q;
                    //   playfield->set(x+dirs[d][0]*j,y+dirs[d][1]*j,WHITE);
		    blasted->set(x+dirs[d][0]*j,y+dirs[d][1]*j,1);
		    }
		    
                    //q++;
		 //   gravity(p);
	 /*    
                    for (j=0; j<top_rustic->total_players; j++)
                        if (j!=p)
                            addline(j,p);
			    */
                    }
                }
            }
        }
    }

    for (y=0; y<MY; y++) for (x=0; x<MX; x++)
	    if (blasted->get(x,y))
	    {
		    playfield->set(x,y,WHITE);
		    top_rustic->players[p]->score+=10;
	    }
    delete blasted;
    }

void jewel::gravity(int p)
{
	int i,j,k;

       for (j=MY-1; j>=1; j--)
           for (k=top_rustic->players[p]->r; k<top_rustic->players[p]->r+fX; k++)
		   if (playfield->get(k,j)==WHITE)
			   playfield->set(k,j,BKGR);
       
		    i=1;
		    while(i)
			{
			i=0;
                        for (j=MY-1; j>=1; j--)
                            for (k=top_rustic->players[p]->r; k<top_rustic->players[p]->r+fX; k++)
                                if (playfield->get(k,j)==BKGR & playfield->get(k,j-1)!=BKGR)
				{
                                    playfield->set(k,j,playfield->get(k,j-1));
				    playfield->set(k,j-1,BKGR);
				    i=1;
				}
			}
			
}

void jewel::addline(int p, int f)
    {
    int m,n,x,y,i,j;

/*    if (top_rustic->players[p]->alive==1)
    for (m=0; m<4; m++)
        for (n=0; n<4; n++)
            if (piece(top_rustic->players[p]->p,m,n,top_rustic->players[p]->j)!=0)
                playfield->set(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y,0);
*/
    for (y=0; y<MY-2; y++)
        for(x=0; x<fX; x++)
            playfield->set(x+top_rustic->players[p]->r,y,
            playfield->get(x+top_rustic->players[p]->r,y+1));
    for (x=0; x<fX; x++)
        playfield->set(x+top_rustic->players[p]->r,
            MY-2, f+1);
    playfield->set(top_rustic->players[p]->r+rand()%fX,MY-2,0);

    if (top_rustic->players[p]->alive==1)
    if (checkpiece(p)!=0)
        {
        top_rustic->players[p]->y--;
	/*
        for (m=0; m<4; m++)
            for (n=0; n<4; n++)
                if (piece(top_rustic->players[p]->p,m,n,top_rustic->players[p]->j)!=0)
                    playfield->set(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y,p+1);
*/
        drop.play(); newpiece(p);
        }
/*
    if (top_rustic->players[p]->alive==1)
    for (m=0; m<4; m++)
        for (n=0; n<4; n++)
            if (piece(top_rustic->players[p]->p,m,n,top_rustic->players[p]->j)!=0)
                playfield->set(m+top_rustic->players[p]->x,n+top_rustic->players[p]->y,p+1);
 */   }


