#include "nibbles.h"

  int nibbles_lens[] =
    {
    5,10,25,35,50,65,75,100,150,200
     };

void nibbles::next_turn()
    {
    int x,y,i,j;

    if (special==1)
        {
        special=0;
        newgame(cur_level+1);
        }

    i=0;
    for (j=0; j<top_rustic->total_players; j++)
        if (top_rustic->players[j]->alive==1)
            {
            i++;
            move_player(j);
            }

    update_level(-1);



    x=0;
    if (i==0)
        {
        for (j=0; j<top_rustic->total_players; j++)
            if (top_rustic->players[j]->lives>0)
                x+=top_rustic->players[j]->lives;                    
        if (x==0)
            alive=0;
            else
            newgame(cur_level);
        }

    }

int nibbles::game_resize_pictures()
    {
    int x,y;

    int i;

    PX=game_x/MX;
    PY=game_y/MY;
    if (PX<1 | PY<1) return(-1);

//        for (i=0; i<MX*MY; i++)
    playfield->all_on();

    ginit=1;
    return(1);
    }


nibbles::nibbles(rustic *r)
    : game(r)
    {
    gamename="Nibbles";
    cur_thing=0;
    cur_level=0;
    playfield=new pfield(MX,MY);

    PX=8;
    PY=8;

    count=0;
    refresh_rate=.1f;
    top_rustic->key_form=top_rustic->HOLD_ON;
    crash.load("bang.wav");
    extend.load("zoom.wav");
    newgame(0);
    }

void nibbles::newnib()
    {
    int x=0,y=0;
    while (playfield->get(x,y)!=BKGR)
        {
        x=rand()%MX;
        y=rand()%MY;
        }
    playfield->set(x,y,THING);
    cur_thing++;
    if (cur_thing==10) newgame(cur_level+1);
    }


void nibbles::newgame(int level)
    {
    int i,x,y;
    cur_level=level;
    cur_thing=0;
    for (x=0; x<MX; x++)
        for (y=0; y<MY; y++)
            playfield->set(x,y,BKGR);
    for (x=0; x<MX; x++)
        {
        playfield->set(x,0,WALL);
        playfield->set(x,MY-1,WALL);
        }
    for (y=0; y<MY; y++)
        {
        playfield->set(0,y,WALL);
        playfield->set(MX-1,y,WALL);
        }

    switch(cur_level)
        {
        case 0: break;
        case 1: for (x=MX/4; x<MX*3/4; x++)
                    playfield->set(x,MY/2,WALL);
                break;
        case 2: for (y=0; y<MY*2/3; y++)
                    {
                    playfield->set(MX/3,y,WALL);
                    playfield->set(MX*2/3,MY-1-y,WALL);
                    }
                break;
        case 3: for (x=0; x<MX/2-3; x++)
                    {
                    playfield->set(x+1,MY/2,WALL);
                    playfield->set(MX-x-1,MY/2,WALL);
                    }
                for (y=0; y<MY/2-3; y++)
                    {
                    playfield->set(MX/2,y+1,WALL);
                    playfield->set(MX/2,MY-y-1,WALL);
                    }
                break;
        case 4: for (y=0; y<MY; y++)
                    playfield->set(MX/2,y,WALL);
                playfield->set(MX/2,MY/2,0);
                break;
        case 5: for (y=0; y<MY*2/3; y++)
                    {
                    playfield->set(MX/3,y,WALL);
                    playfield->set(MX*2/3,y,WALL);
                    }
                for (y=MY/3; y<MY; y++)
                    {
                    playfield->set(MX/6,y,WALL);
                    playfield->set(MX/2,y,WALL);
                    playfield->set(MX*5/6,y,WALL);
                    }
                break;
        case 6: for (x=1; x<7; x++)
                    {
                    for (y=0; y<MY; y++)
                        playfield->set(MX*x/7,y,WALL);
                    playfield->set(MX*x/7,MY/2,0);
                    }
                break;
        default:for (x=1; x<10; x++)
                    {
                    for (y=0; y<MY; y++)
                        playfield->set(MX*x/10,y,WALL);
                    playfield->set(MX*x/10,1+(MY-3)*((x+1)%2),0);
                    }
                break;
        }            
        
    for (i=0; i<top_rustic->total_players; i++)
        if (top_rustic->players[i]->lives>0)
        {
        top_rustic->players[i]->x=MX/4+(MX/2)*(i%2);
        top_rustic->players[i]->y=MY/4+(MY/2)*(i/2);
        top_rustic->players[i]->len=0;
        top_rustic->players[i]->alive=1;
        top_rustic->players[i]->moved=1;
        top_rustic->players[i]->direction[1]=1;
        top_rustic->players[i]->calc_mxmy();
       // playfield->set(top_rustic->players[i]->x,top_rustic->players[i]->y,i+1);
        }

    newnib();

    alive=1;

    char s[80];
    sprintf(s,"Round %d",cur_level+1);
    pause(s);
    }



int nibbles::game_update(vid *g)
    {
    int x,y;
    int c=0;
    int i;
    int color=-1;  int nc;   int newc;
    
    if (ginit==1)
    {
    for (y=0; y<MY; y++)
        for (x=0; x<MX; x++)
            if (playfield->a_get(x,y)==1)
            {

                nc=playfield->get(x,y);
                nc=nc&0xf;
                if (nc!=color)
                    {
                    color=nc;
                    if (nc==0 | nc==15 | nc==13)
                        newc=nc;
                        else
                        newc=top_rustic->players[nc-1]->color;
                    }

                g->fillrect(newc,x*PX,y*PY,PX,PY);
                playfield->a_set(x,y,0);
                c++;
            }
    }

    if (c!=0)
        return(1);

    return(0);
    }

void nibbles::move_player(int p)
    {
    int x=top_rustic->players[p]->x;
    int y=top_rustic->players[p]->y;
    int mx=top_rustic->players[p]->mx;
    int my=top_rustic->players[p]->my;

    int i,j,xx,yy;
    int nx,ny;

    nx=x+mx;ny=y+my;

    int r=0;

    if (playfield->get(nx,ny)==THING)
        {
        extend.play();
        top_rustic->players[p]->score+=10;
        top_rustic->players[p]->len++;
        playfield->set(nx,ny,0);
        update_level(p);

        playfield->set(nx,ny,p+1+(nibbles_lens[top_rustic->players[p]->len]*16));
        top_rustic->players[p]->x=nx;
        top_rustic->players[p]->y=ny;
        top_rustic->players[p]->moved=1;

        newnib();
        }
        else
        {
        if (playfield->get(nx,ny)!=BKGR)
            {
            top_rustic->players[p]->alive=0;
            crash.play();
            top_rustic->players[p]->lives--;

            for (i=0; i<top_rustic->total_players; i++)
                if (top_rustic->players[i]->alive==1)
                    top_rustic->players[i]->score+=25;
            return;
            }

        playfield->set(nx,ny,p+1+(nibbles_lens[top_rustic->players[p]->len]*16));
        top_rustic->players[p]->x=nx;
        top_rustic->players[p]->y=ny;
        top_rustic->players[p]->moved=1;
        }
    }

void nibbles::update_level(int p)
    {
    int x,y;
    int cp,cn,c;
    for (y=0; y<MY; y++)
    for (x=0; x<MX; x++)
        {
        c=playfield->get(x,y);
        cp=c&0xf;
        cn=c>>4;
        cn=cn&0xfff;
        if ((cp-1)==p & p!=-1)
            cn+=(nibbles_lens[top_rustic->players[p]->len]-nibbles_lens[top_rustic->players[p]->len-1]);

        if (cn>0)
            {
            if (p==-1) cn--;

            if (cn==0)
                playfield->set(x,y,0);
                else
                playfield->set(x,y,cn*16+cp);
            }
        }
    }



nibbles::~nibbles()
    {
    delete playfield;
    }
