#ifndef PLAYER_H
#define PLAYER_H

#define MAX_PNAMELEN 12

#include "allegro.h"
class rustic;

#define PLAYER_UP 0
#define PLAYER_DOWN 1
#define PLAYER_LEFT 2
#define PLAYER_RIGHT 3

class player
    {
    public:
    static const int UP=0;
    static const int DOWN=1;
    static const int LEFT=2;
    static const int RIGHT=3;
    int x, y;
    double dbl_x,dbl_y;
    long score;
    long pscore;
    int plives;
    int rusticscore;
    int moved;
    char name[MAX_PNAMELEN+1];
    int keys[4];
    int direction[4];
    double dmx,dmy; //has distance association, for quick moves by mouse
    int mx, my;
    int color;
    int alive;
    int cur_direction;
    int lives;
    int j,r,jl,p;
    int len;
    rustic *rustc;
    void calc_mxmy();
    player(char *n, int c,rustic *rst);
    };


#endif
