#ifndef H_DVIDW
#define H_DVIDW

//#include "../settings.h"
#include "dvid.h"
#include "allegro.h"

//double buffered is default
#define DVIDW_DIRECT_WRITES  1

//a vga/vesa mode is default
#define DVIDW_USE_ANYMODE    2

//note, getmpointer will only work when using
//mode 13 / svga ("not any mode") and double buffering!
//otherwise, no such luck

//because modex doublebuffer is in video ram
//and without a double buffer you can't get a pointer



class dvidw : public dvid
    {
    public:
        int myparams;
        int using_simplemode;
        dvidw(int parmams=0, int mx=0, int my=0);

        BITMAP *dbuf;

        void showpal(void);
        void resize(int mx, int my);
        unsigned char *getmpointer();

        void display_area(unsigned int x, unsigned int y, unsigned int mx, unsigned int my);


        virtual void fillrect(unsigned char c, unsigned int x, unsigned int y, unsigned int mx, unsigned int my);
        virtual void dopixel(unsigned char c, unsigned int x, unsigned int y);
        virtual int getpixel(unsigned int x, unsigned int y);
        virtual void doblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my);
        virtual void idoblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my);
        virtual void getblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my);

        virtual void domvid(mvid *v, unsigned int x, unsigned int y);
        virtual void idomvid(mvid *v, unsigned int x, unsigned int y);

        //the destructor..
        ~dvidw();
    };

#endif
