#ifndef H_SVID
#define H_SVID

#include "vid.h"
#include <stdio.h>

class svid : public vid
    {
    public:

        unsigned int MX, MY;
        unsigned int PX, PY;

        vid *myvid;

        svid(vid *mv, int px, int py, int mx, int my)
            {
            myvid=mv;
            PX=px;
            PY=py;
            MX=mx;
            MY=my;
            }

        void fillrect(unsigned char c, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
            {
            if ((x+mx)<=MX & (y+my)<=MY)
                myvid->fillrect(c,x+PX,y+PY,mx,my);
            }

        void dopixel(unsigned char c, unsigned int x, unsigned int y)
            {
            if (x<MX & y<MY)
                myvid->dopixel(c,x+PX,y+PY);
            }

        int getpixel(unsigned int x, unsigned int y)
            {
            if (x<MX & y<MY)
                return(myvid->getpixel(x+PX,y+PY));
            return(0);
            }

        void doblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
            {
            if ((x+mx)<=MX & (y+my)<=MY)
                myvid->doblock(v,x+PX,y+PY,mx,my);
            }

        void idoblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
            {
            if ((x+mx)<=MX & (y+my)<=MY)
                myvid->idoblock(v,x+PX,y+PY,mx,my);
            }

        void getblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my)
            {
            if ((x+mx)<=MX & (y+my)<=MY)
                myvid->getblock(v,x+PX,y+PY,mx,my);
            }

        void domvid(mvid *v, unsigned int x, unsigned int y)
            {
            myvid->domvid(v,x+PX,y+PY);
            }

        void idomvid(mvid *v, unsigned int x, unsigned int y)
            {
            myvid->idomvid(v,x+PX,y+PY);
            }

        ~svid()
            {
            }
    };
#endif
