#include "vid.h"
#include <stdlib.h>
#include <stdio.h>

vid::vid() {}
void vid::resize(int mx, int my)
    {
    MX=mx;
    MY=my;
    }
void vid::fillrect(unsigned char c, unsigned int x, unsigned int y, unsigned int mx, unsigned int my) {}
void vid::clearvid(void)
    { fillrect(0,0,0,MX,MY); }


void vid::dopixel(unsigned char c, unsigned int x, unsigned int y) {}
int vid::getpixel(unsigned int x, unsigned int y) {}

void vid::doblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my) {}
void vid::getblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my) {}


void vid::idoblock(unsigned char *v, unsigned int x, unsigned int y, unsigned int mx, unsigned int my) {}
void vid::idomvid(mvid *v, unsigned int x, unsigned int y)
    {
    idoblock(v->getmpointer(),x,y,v->MX,v->MY);
    }

void vid::domvid(mvid *v, unsigned int x, unsigned int y)
    {
    doblock(v->getmpointer(),x,y,v->MX,v->MY);
    }

vid::~vid() {}



#define sign(x) (((x)<0)?(-1):(1))
#define qabs(x) (((x)<0)?-(x):(x))

void vid::line(int c, int x1, int y1, int x2, int y2)
    {
    int dx=qabs(x2-x1);
    int dy=qabs(y2-y1);
    int s1=sign(x2-x1);
    int s2=sign(y2-y1);
    int dx2,dy2;
    int error_term,i;
    unsigned char exchange=0;

    if(dy>dx)
        {int temp=dx;dx=dy;dy=temp;exchange=1;}

    dx2=(dx<<1);
    dy2=(dy<<1);
    error_term=(dy-dx)<<1;
    for (i=1;i<=dx;++i)
        {
        dopixel(c,x1,y1);
        while(error_term>=0)
            {
            if (exchange)
                x1+=s1;
                else
                y1+=s2;
            error_term-=dx2;
            }
        if(exchange)
            y1+=s2;
            else
            x1+=s1;
        error_term+=dy2;
        }
    }

void vid::floodfill(unsigned char c, unsigned int x, unsigned int y)
    {
    int dirs[4][2] = {1,0,-1,0,0,1,0,-1};
    int max_floodstack=(MX+MY)*2;
    int *floodstack = new int[max_floodstack*2];
    int stackpos=0;

    floodstack[stackpos*2+0]=x;
    floodstack[stackpos*2+1]=y;
    stackpos++;

    unsigned char bg=getpixel(x,y);
    if (bg==c) return;
    dopixel(c,x,y);

    int cx,cy;
    int chgs;
    int mss=0;

    while (stackpos>0)
        {
        if (stackpos>mss) mss=stackpos;

        cx=floodstack[(stackpos-1)*2+0];
        cy=floodstack[(stackpos-1)*2+1];

        int done=0;
        int i;
        int pu,pd;
        int ppu,ppd;

        ppu=((getpixel(cx,cy-1)!=bg)?1:0);
        ppd=((getpixel(cx,cy+1)!=bg)?1:0);

        chgs=0;
        while (done==0)
            {
            pu=((getpixel(cx,cy-1)!=bg)?1:0);
            pd=((getpixel(cx,cy+1)!=bg)?1:0);

            if (pu!=ppu | pd!=ppd)
                {
                if (stackpos<max_floodstack)
                    {
                    floodstack[stackpos*2+0]=cx;
                    floodstack[stackpos*2+1]=cy;
                    dopixel(12,cx,cy);
                    stackpos++;
                    }
                    else
                    c=13;
                }

            done=1;
            for (i=0; i<4; i++)
                {
                int nx=cx+dirs[i][0];
                int ny=cy+dirs[i][1];
                if (nx>=0 & ny>=0 & nx<MX & ny<MY)
                    if (getpixel(nx,ny)==bg)
                        {
                        cx=nx;
                        cy=ny;
                        dopixel(c,cx,cy);
                        if (i>1)
                            {
                            //ppu=((getpixel(cx,cy-1)!=bg)?1:0);
                            //ppd=((getpixel(cx,cy+1)!=bg)?1:0);
                            ppu=-1;
                            ppd=-1;
                            }
                            else
                            {
                            ppu=pu;
                            ppd=pd;
                            }
                        i=4;
                        done=0;
                        chgs++;
                        }
                }
            }

        if (chgs==0)
            stackpos--;
        }

    /*
    char *str=new string[6];
    sprintf(str,"%5d",mss);
    font *fnt=new sfont();

      */

    delete [] floodstack;
    }



